#!/usr/bin/python

# ====================================================================
# IMPORT PYTHON COMMANDS
# ====================================================================
import os, sys, string, math, commands, time

# ====================================================================
#       Take the command line arguments
# ====================================================================

if len(sys.argv)!=2:
        print __doc__

steprange = sys.argv[1] 

# ====================================================================
# Copy in the relevant velo files
Modelname='NewViscContrast_Slab23E'
# ====================================================================
pauseSeconds=25
newmin=int(0)
newmax=int(0)

# ====================================================================
#for n in range(0,int(steprange)+1,100):
for n in range(0,int(steprange)+1,100):
#for n in range(int(steprange),int(steprange)+100,100):		
# ====================================================================
	step=str(n)
	directory='/home/kara/Models/'+Modelname+'/Data/*'
	coord_dir='/home/kara/Models/'+Modelname+'/Data/'
	velo_dir='Velo_files_embd'
	print "copying in velos from the directory into Velo_files_embd"
	os.system("cp "+directory+"/embd.velo.*."+step+" "+velo_dir )  
	os.system("cp "+directory+"0/embd.time .")
	
	# ====================================================================
	#      Copy  Velo files from original run
	# ====================================================================
	# Get all the velo files from the previous run
	# here Run_2 and for a certain timestep and put 
	# them into a new directory.
	velos = commands.getoutput('ls '+velo_dir+'/*') 
	veloslist = string.split(velos,'\n')
	for i in veloslist:
        	veloposition=string.find(i,'velo')
        	num=len(str(step))
        	if num == 1:
        	        shift=-2
        	if num == 2:
        	        shift=-3
        	if num == 3:
        	        shift=-4
        	if num == 4:
        	        shift=-5
        	if num == 5:
        	        shift=-6
        	#stepposition=string.find(i,'velo.*.*')
        	#stepposition=string.find(i,str(step))
        	stringname=i[0:veloposition+5]  
        	cap = i[veloposition+5:shift]
        	#cap = i[veloposition+5:stepposition]
        	new_step = str(0)
        	name=(''+stringname+cap+'.'+new_step)
        	os.system('mv '+i+ ' '+name)
	# ====================================================================
	# Make a directory or clean up an old set fo files
	# ====================================================================
	os.system("mkdir New_Velos")
	os.system("rm New_Velos/*")
	#coord_dir='/home/lydia/ModelRuns/Jan_2008/DIP/Coupled_G33_R257_Ex_trc_tole_new90/Data/'
	# ====================================================================
	#	Remove the lithosphere from the files
	# ====================================================================
	depth=200.
	rdepth=1-(depth/6371.)
	for i in range(0,128):
		#for i in range(0,1):
		# Open coordinate file
		coorfile=open(coord_dir+str(i)+"/embd.coord."+str(i),'r')
		print "========================="
		print "embd.velo."+str(i)+".0"
        	print "========================="
		# Read the coordinate file
		coor_read=coorfile.readlines()
		# Create a new velo file
		newvelo=open("Altembd.velo."+str(i)+".0","w")
		#read first two lines of velofile
		velo_file=open(velo_dir+"/embd.velo."+str(i)+".0","r")
		velo_read1=velo_file.readline()
		line1=velo_read1
		newvelo.write(line1)
		velo_read2=velo_file.readline()
		line2=velo_read2
		newvelo.write(line2)
		velo_file.close()
		#
		velo_file=open(velo_dir+"/embd.velo."+str(i)+".0","r")
		velo_read=velo_file.readlines()
		for m in range(len(velo_read)-2):	
			velo_line=velo_read[m+2]
			velo_colat=velo_line.split(' ')[0]
			velo_long=velo_line.split(' ')[1]
			velo_r=velo_line.split(' ')[2]
			velo_t=velo_line.split(' ')[3]
			rval=float(coor_read[m+1].split(' ')[2].split('\n')[0])
			if rval > rdepth:
				"setting velo to 1"
				velo_t='1.000000e-00\n'
			else:
				velo_t=velo_t
			line=(velo_colat+' '+velo_long+' '+velo_r+' '+velo_t)
			newvelo.write(line)
		newvelo.close()
		velo_file.close()
		os.system("mv Altembd.velo."+str(i)+".0 New_Velos/embd.velo."+str(i)+".0")			
	# LAUNCH CITCOMS
	os.system("~/CitcomS/bin/citcoms Surface.cfg")
	print "launched run"
	print "==============================================="
        print "Checking for stderr.txt"
        print "==============================================="
        logfile=commands.getoutput("ls stderr.txt ")
	X=1
	if 'No such file or directory' in logfile:
		#X=1
		print " Run not done yet"
		print " Going to pause for a seconds:",pauseSeconds
		time.sleep(int(pauseSeconds))
	while X == 1:
		logfile=commands.getoutput("ls stderr.txt ")
		if 'No such file or directory' in logfile:
			X=1
			print " Run not done yet"
			print " Going to pause for a seconds:",pauseSeconds
			time.sleep(int(pauseSeconds))
		else:
			X=0
			print "we have a stderr file"
			print "we need to make and s file"
			#os.system("/home/kara/CitcomS/visual/batchsurf.py localhost DataSurf surface 0 257 257 65 1 8 8 2")
			os.system("batchsurf.py localhost DataSurf surface 0 257 257 65 1 8 8 2")
			os.system("autocombine.py localhost pid* 0 ")
			#print "Must clean both the pidfile and the stderr.txt"
			#os.system('cp stderr.txt errorfile')
			#os.system("rm std* pid*")
			os.system("mv surface.surf0.0 surface.surf0."+str(step)+"")
			os.system("mv surface.surf0."+str(step)+" SURFACE_CAPFILES/ ")
		        os.system("mv surface.cap00.0 embd.cap00."+str(step)+"")			
			os.system("mv embd.cap00."+str(step)+" SURFACE_CAPFILES/" )
			os.system("rm surface*")
			os.system("rm DataSurf/*")
			os.system("rm New_Velos/*")
			os.system("rm Velo_files_embd/*")
			os.system("rm stdout.txt stderr.txt")
			os.system("rm pid*")


