#!/bin/bash

#----This script is designed to plot the modelled subsidence at one borehole location
#----make sure to change all file PATHS!!

bh_number=0

while (( $bh_number <= 43 ))
    do


pasted_BH_data=BH${bh_number}_depth_age_ts.dat
xy_file=BH${bh_number}_age_depth.xy
region=0/140/-1800/0
projection=X-12/10
boundary_annot=a10g10f5:"Time(Ma)":/a200g200f100:"DynamicTopography(m)"::."${bh_number}":WSne
psfile=graph${bh_number}.ps
pen=0.2/black

#----create a data file with 3 columns: depth, age, timestep....this will be needed to make xy file

paste Model_subs_Slab23E_DoubleRa/Indiv_BHs/BoreHole.${bh_number}.dat age_ts_conversion_Slab23E_DoubleRa.dat > $pasted_BH_data	#CHANGE FOR EACH RUN

#----create xy file with age and depth info

awk '{print $2, $1}' $pasted_BH_data > $xy_file

#----plotting the data using GMT

gmtset LABEL_FONT_SIZE 16p ANNOT_FONT_SIZE_PRIMARY 12p

psbasemap -R$region -J$projection -B$boundary_annot -X4 -K -V > $psfile 

psxy $xy_file -R$region -J -W$pen -O -V >> $psfile

gmtset LABEL_FONT_SIZE 24p ANNOT_FONT_SIZE_PRIMARY 14p


#----CHANGE PATHS FOR EACH NEW RUN

if [ $bh_number == 0 ]; then
mkdir Model_subs_Slab23E_DoubleRa/Subs_Curves
fi

if [ $bh_number == 0 ]; then
mkdir Storage_Slab23E_DoubleRa/XYdata_for_Subs_Curves		
fi


mv graph${bh_number}.ps Model_subs_Slab23E_DoubleRa/Subs_Curves
mv BH${bh_number}_age_depth.xy Storage_Slab23E_DoubleRa/XYdata_for_Subs_Curves	

#----clean up

rm BH${bh_number}_depth_age_ts.dat


#----loop to next borehole

bh_number=$(($bh_number + 1))
 done
