C  BACK-STRIPPING PROGRAM TO CALCULATE UNLOADED BASEMENT SUBSIDENCE             
C  THE PROGRAM ALLOWS FOR TWO POROSITY DEPTH RELATIONS PER LITHOLOGY            
C  AND CAN BE USED TO DEFINE MAXIMUM AND MINIMUM VALUES                         
C  WATER DEPTHS AND SEA LEVEL VARIATIONS MAY BE INCLUDED                        
C  THE WATER DEPTHS MUST BE IN METRES AND THE SEA LEVEL ( ONLY BACK TO          
C  END TRIASSIC USING THE TIME SCALE OF SNELLING 1985)                          
C  ARE ASSUMED TO BE THOSE OF FALVEY AND DEIGHTON (1982)                        
C  RELEVANT FOR THE AUSTRALIAN MARGINS                                          
C INPUT REQUIREMENTS ARE DISCUSSED BELOW WITH EXAMPLES                          
C ---------------------------------------------------------------------         
C               WRITTEN BY KERRY GALLAGHER                                      
C                    RESEARCH SCHOOL OF EARTH SCIENCES                          
C                     1987                                                      
C ---------------------------------------------------------------------         
      PARAMETER (NS=12,NL=30)                                                   
C -----------------------------------------------------------------------       
      REAL ZP(NS),FO(NS),C(NS),FI(NS),CI(NS),SD(NL),SI(NL),SH(NL),SL(NL)        
     &,AGE(NL+1),Z(NL),TPN(NS),AVPS(NS),PW(2),PSG(NS),beta(4)
     &,WATD(NL), CA(NS),F(NS), DET(NS),ZERO(NL,3),DZER(NS),SEA(0:204)                      
       INTEGER IY(NL,3),IS(NL,3),IDCOMP(NL,3)                        
      CHARACTER*1 AGAN,OUT,DEP,TIM,SURF,SEL,TAB                           
      CHARACTER*80 TITLE,DATF,FILE,formation*15
C ------------------------------------------------------------------------      
	SAVE
C       COMMON /CB1/ ZP,FO,C,FI,CI,SD,SI        
C     &,SH,SL,AGE,Z,TPN,AVPS,PW,PSG
C     &,WATD, CA,F, DET,ZERO,DZER,BETA,IY,IS,IDCOMP                       

C  MANTLE DENSITY                                                               
      DATA PM /3.30/                                                            
	tab = char(9)                                              
                                                                                
C -----------------------------------------------------------------------       
                                                                                
501      FORMAT(A80)                                                            
511      FORMAT(5X,A80)                                                         
502      FORMAT(A1)                                                             
601      FORMAT(' NAME OF DATAFILE? ')                                          
602      FORMAT(' ARE DEPTHS IN FEET OR METRES? ')                              
604      FORMAT(' DO YOU WANT TO INCLUDE WATER DEPTHS AND SEA LEVELS')          
605      FORMAT(' WATER LOADED SUBSIDENCE Y OR N ')                             
607      FORMAT(' DO YOU WANT TO INCLUDE AN AGE AT THE SURFACE? ')              
608      FORMAT(' WHAT IS IT(M.Y.)? ')                                          
609      FORMAT(' ENTER 0 FOR COMPACTION MODEL,
     &-1 FOR CEMENTATION MODEL')          
610      FORMAT('  OVERWRITE OUTPUT FILE ? ')                                   
109      FORMAT(5X,' Height above present day sea level  '/5x,I5,' m')          
1100      FORMAT(a1,I5,a1,f7.1,1x,3(a1,f8.1),3(a1,f8.1,A1,f7.1)
     &,3(a1,F8.2)) 
110      FORMAT(4X,I5,5X,I4,1X,':',3(I6,1X),':',3(I6,1X,A1,I4,A1,1X),':'        
     &         ,3(F8.2,1X))                                                         
111      FORMAT(3X,'Observed',4x,'Age',9x,'Basement',25X,'Total',               
     &           28X,'Deposition')                                              
112      FORMAT(2x,'Thickness',17X,'Depth',24X,'Decompacted',28x,'Rate')        
113    FORMAT(5x,'(m)',6x,'(Ma)',11x,'(m)',24x,'Thickness (m)',27x              
     &        ,'(m/Ma)')                                                        
114      FORMAT(1X,' ---------------------------------------------------        
     &------------------------------------------------------')                  
115      FORMAT(5X,' Age at surface of sediments   '/5x,I5,' Ma')                  
119      FORMAT('1')                                                            
1111     FORMAT( ' ARRAY BOUNDS EXCEEDED : STOP !!! ')                          
                                                                                
                                                                                
C ------------------------------------------------------------------------      
C  WATER DENSITY(0.0 IS USED IF WATER LOADING EFFECT IS NOT DESIRED)            
      PW(1) = 0.0
      PW(2) = 1.00

c read in porosity-depth relationship constants, and grain denisty      
      open(10,FILE='PORT.DAT',status='unknown') 
             READ(10,*) (FO(J),C(J),FI(J),CI(J),ZP(J),PSG(J),J=1,NS)            
        CLOSE(10)                                                               
C -------------------------------------------------------------------------     
	WRITE(*,*) ' ENTER INPUT FILE NAME '
	read(*,501) title
        open(10,FILE=TITLE,status='unknown')
	WRITE(*,*) ' ENTER OUTPUT FILE NAME '
	read(*,501) title
        open(11,FILE=TITLE,status='unknown')
                                                                                
C INCLUDE CEMENT IN CALCULATIONS : ENTER -1 FOR TOTAL POROSITY REDUCTION        
C BY CEMENT (I.E. NO COMPACTION), 0 FOR COMPACTION ONLY                         
C NB AS WRITTEN THIS ONLY WORKS FOR THE SINGLE TIER POROSITY DEPTH FUNCTION                
        WRITE(*,609)
	 read(*,*) cem
          do 53 i=1,4                                                           
53           beta(i)  = cem                                               
	write(*,602)
	read(*,502) DEP
	write(*,604) 
	read(*,502) sel
	WRITE(*,607)
	READ(*,502) SURF
	if(SURF.eq.'y'.or.surf.eq.'Y') then 
	 write(*,608)
	 read(*,*) age(1)
	else 
	 age(1) = 0.0
	end if
        AGAN='Y' 	! water loaded subsidence                                                               
                                                                  

        Z(1)=0.0                                                                
 	read(10,501) title
 	write(9,511) title
 	read(10,*) alat,alon
 	read(10,*) bushing,td
 	read(10,*) nz
        CALL ATEST(NZ,NL,*1001)                                                 
	 if(sel.eq.'Y'.or.sel.eq.'y') then 
	do 52 j=2,nz+1
          read(10,*) formation,thick,age(j),sd(j),si(j),sh(j),sl(j),watd(j)
c          read(10,*) thick,age(j),sd(j),si(j),sh(j),sl(j),sl(j),watd(j)
	  z(j)=z(j-1)+thick
52	continue
	else
	do 51 j=2,nz+1
          read(10,*) formation,thick,age(j),sd(j),si(j),sh(j),sl(j)
c          read(10,*) thick,age(j),sd(j),si(j),sh(j),sl(j)
	  z(j)=z(j-1)+thick
51	continue
        END IF                                                               

          IF(DEP.EQ.'F'.OR.DEP.EQ.'f') THEN                                     
              DEPZ=0.0003048                                                    
           ELSE                                                                 
              DEPZ=0.001                                                        
           END IF                                                               
              DO 31 I=1,NZ+1                                                    
31               Z(I)=Z(I)*DEPZ                                                 
        IF(AGAN.EQ.'Y'.OR.AGAN.EQ.'y') THEN                                     
         NW=2                                                                   
        ELSE                                                                    
         NW=1                                                                   
        END IF                                                                  
                                                                                
                                                                                
C END INPUT                                                                     
C ---------------------------------------------------------------------         
C ---------------------------------------------------------------------         
C                                                                               
C THIS SECTION IS THE MAIN CALCULATING AREA OF THE PROGRAM.                     
C THE OLDEST (DEEPEST) UNIT IS ' BROUGHT TO THE SURFACE '                       
C FIRST AND THE OTHER UNITS ARE SUCCESSIVELY ' REDEPOSITED '                    
C THE WHOLE ROUTINE IS PERFORMED TWICE FOR MAXIMUM AND MINIMUM                  
C VALUES.                                                                       
C THE TWO TIER POROSITY/DEPTH RELATIONSHIP IS USED AND THE CALCULATION          
C ALLOWS FOR A UNIT TO BE PARTLY ABOVE THE DEPTH WHERE THE RELATIONSHIP         
C CHANGES(ZP) AND PARTLY BELOW IT AT THE SAME TIME                              
C THE METHOD USED IS CLEARLY DETAILED IN SCLATER AND CHRISTIE (1980)            
C THE ANSWERS ARE CALCULATED RELATIVE TO PRESENT DAY SEA LEVEL (I.E. THE        
C INPUT DEPTHS ARE ASSUMED TO BE THE ONCE TRUE DEPTH BELOW SEA LEVEL)           
C THUS IF THE SURFACE IS NOW ABOVE SEA LEVEL THIS IS ASSUMED TO BE DUE          
C TO POST DEPOSITIONAL UPLIFT WHICH WILL BE REFLECTED IN THE SUBSIDENCE         
C CURVES IF THE SURFACE LITHOLOGY HAS BEEN GIVEN AN AGE GREATER THAN 0.0        
C -----------------------------------------------------------------------       
        LA=1                                                                    
       DO 25 L=1,3                                                              
        DO 21 J=NZ+1,2,-1                                                         
C                                                                               
C ----------------------------------------------------------------------        
C  CALCULATE ZERO DEPTH DECOMPACTED THICKNESS FOR RATE OF SEDIMENTATION         
C  ACTUALLY  THIS SECTION CALCULATES  THE THICKNESS OF SOLID MATERIAL           
C IN THE UNIT AND THIS IS USED TO OBTAIN A RATE                                 
              NN=0                                                              
         DO 251 N=LA,LA+3                                                       
              NN=NN+1                                                           
             IF(BETA(NN).GE.0) THEN                                             
              CALL DZERO(Z(J-1),Z(J),DZER(N),CI(N),FI(N),beta(nn))              
             ELSE                                                               
              DZER(N)=(Z(J)-Z(J-1))*(1.-FI(N))                                  
             END IF                                                             
251      CONTINUE                                                               
            ZERO(J,L)=DZER(LA)*SD(J)+DZER(LA+1)*SI(J)+DZER(LA+2)*SH(J)          
     &   +DZER(LA+3)*SL(J)                                                      
                                                                                
C ----------------------------------------------------------------------        
                                                                                
       TOP=0.0                                                                  
       PSM=0.0                                                                  
       DO 22 K=J,NZ+1                                                           
        DET(1)=SD(K)                                                            
        DET(2)=SI(K)                                                            
        DET(3)=SH(K)                                                            
        DET(4)=SL(K)                                                            
       DO 456 MN=1,4                                                            
        DET(MN+4)=DET(MN)                                                       
 456    DET(MN+8)=DET(MN)                                                       
                                                                                
          nn=0                                                                  
         DO 23 N=LA,LA+3                                                        
                                                                                
           ZVAL=0.0                                                             
           CA(N)=C(N)                                                           
            F(N)=FO(N)                                                          
           IF(DET(N).EQ.0.0) GO TO 231                                          
           nn=nn+1                                                               
c allow for total porosity infill by cementation                                
        if(beta(nn).lt.0) then                                                  
          tpn(n)=top+z(k)-z(k-1)                                                
          go to 23                                                              
        end if                                                                  
                                                                                
C test for the top depth relative to zp, the point of change in the two-tier    
C porosity functions                                                            
C (i) top depth of decompacted depth greater than depth zp                      
                                                                                
       IF(TOP.GE.ZP(N)) THEN                                                    
         CALL COMPO(TOP,ZVAL,Z(K-1),Z(K),C(N),FO(N),beta(nn))                   
C                       (ii) present depth of base of unit greater than zp      
       ELSE IF(Z(K).LT.ZP(N)) THEN                                              
         CALL COMPO(TOP,ZVAL,Z(K-1),Z(K),CI(N),FI(N),beta(nn))                  
C                           (iii) present depth of top of unit less than zp     
       ELSE IF(Z(K-1).LE.ZP(N)) THEN                                            
C                           calculate the decompacted thickness of              
C                           the interval between the top of the unit and zp     
         CALL COMPO(TOP,ZVAL,Z(K-1),ZP(N),CI(N),FI(N),beta(nn))                 
C                                if the calculated decompacted depth            
C                                is less than zp                                
         IF(ZVAL.LT.ZP(N)) THEN                                                 
           CALL COMPACT(ZP(N),ZVAL1,ZVAL,ZP(N),C(N),FO(N),CI(N),FI(N),          
     &                  beta(nn))                                               
            CALL COMPO(ZP(N),ZVAL,ZVAL1,Z(K),C(N),FO(N),beta(nn))               
         END IF                                                                 
C                             else if the base of the unit is greater than zp   
        ELSE IF(Z(K-1).GT.ZP(N)) THEN                                           
         CALL COMPO(TOP,ZVAL,Z(K-1),Z(K),CI(N),FI(N),beta(nn))                  
C                              check if the decompacted depth is below  zp      
         IF(ZVAL.GT.ZP(N)) THEN                                                 
            CALL COMPO(ZP(N),ZVAL,ZVAL1,Z(K),C(N),FO(N),beta(nn))               
         END IF                                                                 
        END IF                                                                  
                                                                                
                                                                                
231      TPN(N)=ZVAL                                                            
                                                                                
                                                                                
23    CONTINUE                                                                  
                                                                                
                                                                                
             BASE=TPN(LA)*SD(K)+TPN(LA+1)*SI(K)+TPN(LA+2)*SH(K)                 
     &   +TPN(LA+3)*SL(K)                                                       
           THICK=BASE-TOP                                                       
C DECOMPACTED THICKNESS OF MOST RECENT UNIT IN METRES                           
           IF(K.EQ.J) THEN                                                      
                IDCOMP(J,L)=NINT(THICK*1000.)                                   
           END IF                                                               
                                                                                
C -----------------------------------------------------------------             
C CALCULATION OF THE POROSITY AND MEAN DENSITY OF THE NEW LAYER                 
C SEE SCLATER AND CHRISTIE(1980), JGR, EQNS 21-23,PAGE 3735.                          
C -----------------------------------------------------------------             
             DO 27 N=LA,LA+3                                                    
               IF(DET(N).EQ.0.0) GO TO 271                                      
               IF(TOP.GE.ZP(N)) GO TO 41                                        
               IF(BASE.LE.ZP(N)) GO TO 42                                       
               IF(BASE.GT.ZP(N)) GO TO 43                                       
                                                                                
43             FNA=FI(N)/CI(N)                                                  
               FNA=FNA*(EXP(-CI(N)*TOP)-EXP(-CI(N)*ZP(N)))                      
               FNB=FO(N)/C(N)                                                   
               FNB=FNB*(EXP(-C(N)*ZP(N))-EXP(-C(N)*BASE))                       
               FNA= FNA*(ZP(N)-TOP)/THICK                                       
               FNB= FNB*(BASE-ZP(N))/THICK                                      
               FN=(FNA+FNB)/THICK                                               
               GO TO 45                                                         
42          FO(N)=FI(N)                                                         
            C(N)=CI(N)                                                          
41      FN=FO(N)/C(N)                                                           
        FN=FN*(EXP(-C(N)*TOP)-EXP(-C(N)*BASE))                                  
        FN=FN/THICK                                                             
45    AVPS(N)=FN*PW(2)+(1.-FN)*PSG(N)                                           
271       C(N)=CA(N)                                                            
          FO(N)=F(N)                                                            
                                                                                
27    CONTINUE                                                                  
                                                                                
                                                                                
      AVERPS=AVPS(LA)*SD(K)+AVPS(LA+1)*SI(K)                                    
     &     +AVPS(LA+2)*SH(K)+AVPS(LA+3)*SL(K)                                   
      PSM=PSM+AVERPS*THICK                                                      
      TOP=BASE                                                                  
22    CONTINUE                                                                  
                                                                                
C                             DECOMPACTED THICKNESS IN METRES                   
       S=BASE*1000.0                                                            
C                             MEAN DENSITY                                      
        PSM=PSM/BASE                                                            
C ----------------------------------------------------------------------        
C TECTONIC SUBSIDENCE WITH OR WITHOUT SEA LEVEL AND WATER DEPTH EFFECTS         
C N.B. THIS ASSUMES THAT IF THE SEDIMENTS WERE DEPOSITED UNDER 0 DEPTH          
C WATER  THEN THE SEALEVEL EFFECT IS A DC SHIFT EQUAL TO THE SEALEVEL           
C DIFFERENCE AT TIME t AND PRESENT I.E. SEDIMENTS ARE ASSUMED TO HAVE BEEN      
C DEPOSITED TO CONTEMPORARY SEALEVEL                                            
       IS(J,L)=NINT(S)         
	Y=S*(PM-PSM)/(PM-PW(NW))                                                        
          
      IF((SEL.EQ.'Y'.OR.SEL.EQ.'y').AND.WATD(J).ge.0.0) THEN                    
        IY(J,L)=NINT(Y+WATD(J)-(SEALVL(AGE(J-1))-SCORR)*PM/(PM-PW(2)))          
      ELSE                                                                      
	IY(J,L)=NINT(Y)                                                         
      END IF                                                                                                                                                    
21    CONTINUE                                                                  
      LA=LA+4                                                                   
25    CONTINUE                                                                  
                                                                                
C -------------------------------------------------------------------------     
C     OUTPUT RESULTS                                                                                                                    
             WRITE(11,*)                                                      
             WRITE(11,114)                                                    
             WRITE(11,511) TITLE                                                
             WRITE(11,114)                                                      
	     write(11,*) ' Latitude ', alat, '  Longtitude  ',alon	
      WRITE(11,*)' Kelly Bushing elevation ',bushing,' Total depth  '
     &    ,td
	     if(cem.eq.-1) then 
	      write(11,*) '***** Cementation model used *****'
	     else 
	      write(11,*) '***** Compaction model used *****'
	     end if
	     WRITE(11,114)
             WRITE(11,111)                                                      
             WRITE(11,112)                                                      
             WRITE(11,113)                                                      
             WRITE(11,114) 
	do 30 i=2,nz+1
	 NAGE=NINT(AGE(I))  	                                                   
	 NDZ=NINT((Z(I)-Z(I-1))*1000.)                                          
         DAGE=(AGE(I)-AGE(I-1))/1000.                                           
         IF(DAGE.EQ.0.0) DAGE=1000. 
	
       WRITE(11,110) NDZ,NAGE,IY(I,1),IY(I,2),IY(I,3),IS(I,1),'(',             
     &   IDCOMP(I,1),')',IS(I,2),'(',IDCOMP(I,2),')',IS(I,3),'(',              
     &   IDCOMP(I,3),')',ZERO(I,1)/DAGE,ZERO(I,2)/DAGE,ZERO(I,3)/DAGE         
30	 continue   
           WRITE(11,*)                                                        
         WRITE(11,115) NINT(AGE(1))                                        
          WRITE(11,114)      
	  
	 write(11,*)
	do 301 i=2,nz+1
	 p1=-(AGE(I))  	                                                   
	 NDZ=NINT((Z(I)-Z(I-1))*1000.)                                          
         DAGE=(AGE(I)-AGE(I-1))/1000.                                           
         IF(DAGE.EQ.0.0) DAGE=1000. 
     
      WRITE(11,1100) tab,NDZ,tab,p1,(tab,-float(IY(I,M)),m=1,3)
     & ,(tab,-float(IS(I,m)),tab,float(IDCOMP(I,m)),M=1,3)
     &,(tab,ZERO(I,m)/DAGE,M=1,3)         
301	 continue

         GO TO 1002                                                             
1001     WRITE(9,1111)                                                          
1002     CONTINUE                                                                                                                                                                                        
                                                                                                                                       
        STOP                                                                    
        END                                                                     
C --------------------------------------------------------------------------    
C --------------------------------------------------------------------------    
                                                                                
C NUMERICAL SOLUTION TO THE DEPTH OF THE LOWER SURFACE OF THE DECOMPACTED       
C UNIT. THE METHOD USED IS THE SECANT METHOD (SEE CONTE AND DE BOOR)            
C THIS VERSION IS INCLUDED TO ALLOW FOR A CHANGE IN THE PORSITY DEPTH RELATION  
                                                                                
        SUBROUTINE COMPACT(ZUPPER,ZLOWER,Z1,Z2,C,P,C1,P1,bt)                    
c Macintosh save statement
	  save
C FUNCTION DECLARATIONS                                                         
         FVAL(Z,C,P,ZA,bt)=Z+P/(C+bt)*(EXP(-(C+bt)*Z))-ZA                       
         FDER(Z,C,P,bt)=1.-P*EXP(-(C+bt)*Z)                                     

C                                                                               
         DATA TOL/1.E-5/                                                        
          ZA=FVAL(Z2,C1,P1,0.0,bt)-FVAL(Z1,C1,P1,0.0,bt)                        
     &       +FVAL(ZUPPER,C,P,0.0,bt)                                           
           ZZ1=0.0                                                              
           FZZ1=FVAL(ZZ1,C,P,ZA,bt)                                             
            DO 1 I=1,100                                                        
              ZZ2=ZZ1-FZZ1/FDER(ZZ1,C,P,bt)                                     
             FZZ2=FVAL(ZZ2,C,P,ZA,bt)                                           
             IF(ABS(FZZ2).GT.TOL) THEN                                          
              ZZ1=ZZ2                                                           
              FZZ1=FZZ2                                                         
             ELSE                                                               
              GO TO 9                                                           
             END IF                                                             
          IF(I.EQ.100) WRITE(*,*) ' NO CONVERGENCE IN COMPACT '               
1         CONTINUE                                                              
9        ZLOWER=ZZ2                                                             
         RETURN                                                                 
         END                                                                    
                                                                                
C --------------------------------------------------------------------------    
C --------------------------------------------------------------------------    
                                                                                
C NUMERICAL SOLUTION TO THE DEPTH OF THE LOWER SURFACE OF THE DECOMPACTED       
C UNIT. THE METHOD USED IS THE SECANT METHOD (SEE CONTE AND DE BOOR)            
                                                                                
        SUBROUTINE COMPO(ZUPPER,ZLOWER,Z1,Z2,C,P,bt)                            
c Macintosh save statement
	  save
C FUNCTION DECLARATIONS                                                         
         FVAL(Z,C,P,ZA,bt)=Z+P/(C+bt)*(EXP(-(C+bt)*Z))-ZA                       
         FDER(Z,C,P,bt)=1.-P*(EXP(-(C+bt)*Z))                                   
                                                                    
C                                                                               
         DATA TOL/1.E-5/                                                        
          ZA=FVAL(Z2,C,P,0.0,bt)-FVAL(Z1,C,P,0.0,bt)                            
     &       +FVAL(ZUPPER,C,P,0.0,bt)                                           
           ZZ1=0.0                                                              
           FZZ1=FVAL(ZZ1,C,P,ZA,bt)                                             
            DO 1 I=1,100                                                        
              ZZ2=ZZ1-FZZ1/FDER(ZZ1,C,P,bt)                                     
             FZZ2=FVAL(ZZ2,C,P,ZA,bt)                                           
             IF(ABS(FZZ2).GT.TOL) THEN                                          
              ZZ1=ZZ2                                                           
              FZZ1=FZZ2                                                         
             ELSE                                                               
              GO TO 9                                                           
             END IF                                                             
            IF(I.EQ.100) WRITE(*,*) ' NO CONVERGENCE IN COMPO '                 
1         CONTINUE                                                              
9        ZLOWER=ZZ2                                                             
                                                                                
         RETURN                                                                 
         END                                                                    
C --------------------------------------------------------------------------    
C --------------------------------------------------------------------------    
c subroutine to return a value of sea level ( to 240 Ma)  to within the         
c nearest 1 Ma. If age is greater than 204 then a zero value is returned        
                                                                                
         FUNCTION SEALVL(AGE)                                                   
          REAL SEA(0:204)                                                       
          save   
c	  COMMON /SL/ SEA
c	Block data 
	
       DATA SEA/0.,70.,-15.,20.,45.,0.,50.,45.,20.,-10.,-5.,                    
     &  25.,30.,33.,45.,49.,50.,45.,40.,30.,30.,35.,30.,20.,10.,                
     &  0.,2.,0., 5.,12.,50.,85.,90.,95.,98.,102.,105.,108.,110.,               
     &  113.,115.,117.,118.,120.,120.,120.,121.,122.,122.,123.,125.,            
     &  125., 128., 130., 131., 131., 132., 133., 135., 140., 145.,             
     &  148., 151., 153., 155., 165., 173., 177., 177., 178., 180.,             
     &  185., 189., 192., 194., 195., 196., 197., 196., 194., 191.,             
     &  190., 190., 189., 186., 178., 170., 162., 158., 155., 150.,             
     &  130., 115., 104., 105., 102.,  99.,  98.,  95.,  92.,  88.,             
     &   85.,  82.,  79.,  76.,  73.,  71.,  68.,  65.,  67.,  68.,             
     &   68.,  65.,  62.,  59.,  50.,  42.,  40.,  38.,  34.,  35.,             
     &   37.,  38.,  38.,  40.,  42.,  43.,  43.,  42.,  41.,  41.,             
     &   40.,  40.,  39.,  39.,  39.,  37.,  35.,  34.,  35.,  35.,             
     &   34.,  34.,  33.,  32.,  31.,  29.,  28.,  27.,  26.,  25.,             
     &   24.,  22.,  20.,  19.,  17.,  14.,  10.,   6.,   3.,   1.,             
     &    1.,   3.,   7.,  12.,  14.,  15.,  14.,  12.,  11.,  10.,             
     &    9.,   7.,   4.,   2.,  -2.,  -3.,  -4.,  -4.,  -2.,   0.,             
     &    1.,   2.,   2.,   2.,   1.,   1.,   1.,   0.,  -3.,  -6.,             
     & -9.,-12.,-13.,-13.,-14.,-15.,-16.,-17.,-18.,-18.,-12.,-7.,-3.,3./  
     
          IF(AGE.GT.204.0) THEN                                                 
           SEALVL=0.0                                                           
          ELSE                                                                  
           ISL=IFIX(AGE)                                                        
           SEALVL=SEA(ISL)                                                      
          END IF                                                                
                                                                                
         RETURN                                                                 
         END  	 

     
C ----------------------------------------------------------------------        
                                                                                
C SUBROUTINE TO CALCULATE SOLID THICKNESS                                       
C READ IN INPUT DATA FOR A GIVEN WELL                                           
                                                                                
           SUBROUTINE DZERO(ZUPPER,ZLOWER,DZ,C,P0,bt)                           
                                                                                
           DZA=ZUPPER                                                           
           DZB=ZLOWER                                                           
           DZ=(DZB-DZA)+P0/(C+bt)*(EXP(-(c+bt)*DZB)-EXP(-(C+bt)*DZA))           
C  REMOVE THIS COMMENT  IF THE ZERO DEPTH DECOMPACTED THICKNESS IS              
C  REQUIRED                                                                     
C           DZ=DZ/(1.00-P0)                                                     
                                                                                
       RETURN                                                                   
        END                                                                     
                                                                                
C ---------------------------------------------------------------------         
C TEST ARRAY BOUNDS NOT EXCEEDED                                                
            SUBROUTINE ATEST(N1,N2,*)                                           
             IF(N1.GT.N2) THEN                                                  
               RETURN 1                                                         
             ELSE                                                               
              RETURN                                                            
             END IF                                                             
           END                                                                  
C -----------------------------------------------------------------------       
C                                                                               
C NUMERICAL SOLUTION TO THE DEPTH OF THE LOWER SURFACE OF THE DECOMPACTED       
C UNIT. THE METHOD USED IS THE SECANT METHOD (SEE CONTE AND DE BOOR)            
                                                                                
        SUBROUTINE COMPa(ZLOWER,sZUP,sDS,sC,sP0,sPF)                      
C FUNCTION DECLARATIONS                                                         
	 implicit double precision (a-h,o-z)
	 real*4 zlower,szup,sds,sc,sp0,spf

         FVAL(Z,ZA,DS,C,P0,PF)=-DS+(1.-PF)*(Z-ZA)                               
     &                          +(P0-PF)/C*(dEXP(-C*Z)-dEXP(-C*ZA))             
         FDER(Z,DS,C,P0,PF)=1.-PF-(P0-PF)*dEXP(-C*Z)                            
C                                                                               
         DATA TOL/1d-5/  

	  p0=dble(sp0)
	  pf=dble(spf)
	  c=dble(sc)
	  zup=dble(szup) 
	  ds=dble(sds)                                                     
           ZZ1=tol                                                              
3          FZZ1=FVAL(ZZ1,ZUP,DS,C,P0,PF)                                        
                                                                                
            DO 1 I=1,200                                                        
              ZZ2=ZZ1-FZZ1/FDER(ZZ1,DS,C,P0,PF)                                 
             FZZ2=FVAL(ZZ2,ZUP,DS,C,P0,PF)                                      
             IF(ABS(FZZ2).GT.TOL) THEN                                          
              ZZ1=ZZ2                                                           
              FZZ1=FZZ2                                                         
             ELSE                                                               
              GO TO 9                                                           
             END IF                                                             
       IF(I.EQ.200) THEN                                                        
         WRITE(*,*) ' NO CONVERGENCE IN COMPO ',fzz2                            
         ZZ1=1.D4                                                               
         J=J+1                                                                  
         IF(J.LT.2) GO TO 3                                                     
       END IF                                                                   
                                                                                
1          CONTINUE                                                             
9        ZLOWER=sngl(ZZ2)                                                     
                                                                                
         RETURN                                                                 
         END                                                                    
c -----------------------------------------------------------------------       
c estimate the thickness of sediment deposited in a given tectonic depression   
c  (htb) by using the observed porosity/depth relationship                      
                                                                                
        SUBROUTINE HSCALC(ZLOWER,shtb,sC,sP,spm,spr,spw,spi)
C FUNCTION DECLARATIONS  
	  implicit double precision(a-h,o-z)                 
	  real*4 shtb,zlower,sp,sc,spr,spm,spw,spi
      FVAL(Z,HTB,C,P,pm,pr,pw,pi)=(pm-pr)*z-p/c*(pr-pw)*(dexp(-c*z)-1.)         
     &                   -htb*(pm-pi)                                           
         FDER(Z,HTB,C,P,pm,pr,pw)=(pm-pr)+(pr-pw)*p*dEXP(-C*Z)                  
C                                                                               
         DATA TOL/1.d-5/                                 
	   htb=dble(shtb)
	   c=dble(sc)
	   p=dble(sp)
	   pm=dble(spm)
	   pr=dble(spr)
	   pw=dble(spw)
	   pi=dble(spi)
                      
           ZZ1=TOL                                                              
3          FZZ1=FVAL(ZZ1,HTB,C,P,pm,pr,pw,pi)                                   
                                                                                
            DO 1 I=1,200                                                        
              ZZ2=ZZ1-FZZ1/FDER(ZZ1,HTB,C,P,pm,pr,pw)                           
             FZZ2=FVAL(ZZ2,HTB,C,P,pm,pr,pw,pi)                                 
             IF(ABS(FZZ2).GT.TOL) THEN                                          
              ZZ1=ZZ2                                                           
              FZZ1=FZZ2                                                         
             ELSE                                                               
              GO TO 9                                                           
             END IF                                                             
       IF(I.EQ.200) THEN                                                        
         WRITE(*,*) ' NO CONVERGENCE IN COMPO ',fzz2                            
         ZZ1=1.D4                                                               
         J=J+1                                                                  
         IF(J.LT.2) GO TO 3                                                     
       END IF                                                                   
                                                                                
1          CONTINUE                                                             
9        ZLOWER=sngl(zz2)                                                
                                                                                
         RETURN                                                                 
        end                                                                     
