#!/usr/bin/env python

import sys, string, os, math, commands, random

print "Calculating the different depths"

file=open('Input.txt','r')
print "input file = ", file

RAD = 6371.
#Timestep used from the SAm_F model
timestep=3500


c1=file.readlines()
z_vals = []
OldDepth = 0

for i in range(len(c1)):
	lines = c1[i]
        Depth = lines[14:20]
	#print "Depth = ", Depth	
	if Depth != OldDepth:
		if i > 0:
			OldDepth = Depth
        		z_vals.append(Depth)
			#print "Depth = ", Depth
print "Number of depth layers =", len(z_vals)

# ============================================================
# TRACK SAMPLE 7
# ============================================================
sample='dependencies/basins_north.dat'
sampleb='dependencies/basins_south.dat'
samplec='dependencies/basins_south2.dat'

#Rotated south i.e. back to their original positions
sample_r='dependencies/basins_north_rot.dat'
sampleb_r='dependencies/basins_south_rot.dat'
samplec_r='dependencies/basins_south2_rot.dat'

# Dots for sample1
refs='dependencies/basins_north_green_spots.xy'        # For basemap
refsxy='dependencies/linec_xsect_marker.xy'      # For slices

# Dots for sample2
refsb='dependencies/basins_south_red_spots.xy'        # For basemap
refsxyb='dependencies/linec_xsect_marker.xy'      # For slices

# Dots for sample3
refsc='dependencies/basins_south2_blue_spots.xy'        # For basemap
refsxyc='dependencies/linec_xsect_marker.xy'      # For slices

# ============================================================
#      Sample lines
# ============================================================

os.system("sample1d "+sample+" -Fl -I0.01 -M -V > newsample.xy")
os.system("sample1d "+sampleb+" -Fl -I0.01 -M -V > newsampleb.xy")
os.system("sample1d "+samplec+" -Fl -I0.01 -M -V > newsamplec.xy")

os.system("sample1d "+sample_r+" -Fl -I0.01 -M -V > newsample_r.xy")
os.system("sample1d "+sampleb_r+" -Fl -I0.01 -M -V > newsampleb_r.xy")
os.system("sample1d "+samplec_r+" -Fl -I0.01 -M -V > newsamplec_r.xy")

# ============================================================

os.system("awk '{print($1, 0.8964) } ' newsampleb.xy > lon660.xy")
os.system("awk '{print($1, 0.8964) } ' newsample.xy > lon1_660.xy")
os.system("awk '{print($1, 0.8964) } ' newsamplec.xy > lon2_660.xy")

"""
# ============================================================
# Generating grid files for the Seismic tomography MIT08 model
# This section of the code can be commented out when the files have been generated
# ============================================================
for z in range(len(z_vals)):
        slice=open('slice.xyz','w')        
	dz=float(z_vals[z])
        print "Calculating grid for depth ", dz, "km"

	for i in range(len(c1)):
        	lines = c1[i]
		Lat = lines[0:6]
		Long = lines[7:13]
        	Depth = lines[14:20]
		Val = lines[21:]
		if i > 0:
			if dz == float(Depth):
				slice.write("%e %e %e \n" % (float(Long), float(Lat), float(Val)))
				
	slice.close()				
	os.system("mv slice.xyz  slice."+str(dz)+".xyz")
	os.system("surface -V -R0/360/-90/90 -I0.2/0.2 slice."+str(dz)+".xyz -Gout."+str(dz)+".grd -T0.1")

	os.system("rm *.xyz label.txt")

os.system("mkdir GridFiles")
os.system("mv *.grd GridFiles")
# ============================================================



# ============================================================
# Generating grid files for the SAm model output
# This section of the code can be commented out when the files have been generated
# ============================================================
Rad2Deg = 180.0/math.pi
# Generating grid files for the model output

modelcapdir = 'Data/'
coordfile=open(modelcapdir+"embd.cap00."+str(timestep),'r')
print "coordfile", coordfile
c1=coordfile.readlines()
depth_val= []
for i in range(65):
        z=(c1[i+1].split(' ')[2].split('\n')[0])
        depth_val.append(z)
depth=0
for z in range(len(depth_val)):
        slice=open('slice.xyz','w')
        depth= float(depth_val[z])
        print "Calculating grid for depth ", depth
        coordfile2=open(modelcapdir+"embd.cap00."+str(timestep),'r')
        c2 = coordfile2.readlines()
        for i in range (4293186-1):
                z=(c2[i+1].split(' ')[2].split('\n')[0])
                if float(z) == depth:
                        slice.write(str(float(c2[i+1].split(' ')[1].split('\n')[0])*Rad2Deg)+' '+str(90. - float(c2[i+1].split(' ')[0].split('\n')[0])*Rad2Deg)+' '+(c2[i+1].split(' ')[6].split('\n')[0])+' \n')
        slice.close()
	
        #os.system("surface -V -R270/360/-60/15 -I0.2/0.2 slice.xyz -Lu1 -Ll0 -Gout.grd -T0.1")
	os.system("surface -V -R90/180/-45/45 -I0.2/0.2 slice.xyz -Lu1 -Ll0 -Gout.grd -T0.1")
        # -V = Verbose; -I = inc; -Lu = Upper bound for z, -Ll = Lower bound for z, -T tension factor
        print "depth", depth
        realdepth = int((1.-depth)*RAD)
        print "dimensionalised depth", realdepth        
        os.system("mv out.grd  embd."+str(timestep)+"."+str(depth)+"."+str(realdepth)+".grd")
        os.system("rm slice.xyz")
        depth+=1
        coordfile2.close()
        os.system("mv *.grd  SAm_Grids")

"""

# =================================================================================
#       COLUMN GEOMETRY
# =================================================================================
Ys=['5.5i','3.5i','1.5i']   # Location of figures in y-axis
Xs=['0.4i','4.0i']          # Location of figure in x-axis

# =================================================================================
# SET UP SOME PLOT PROPERTIES
# =================================================================================
#P='-JPa8c/-27.5097098  '
P='-JPa8c/-45.0  '
#R=' -R270/360/0.549694/0.996453 '
R=' -R90/180/0.650/0.999 '
ticks='  -B20/0.1wEsN:."": '

# =================================================================================
#               Plots for the seismic model
# =================================================================================
#os.system("psbasemap  "+P+R+ticks+" -Xa"+Xs[0]+" -Ya"+Ys[0]+" -K > tomo.ps")
# ================================================================================
#os.system("cp TOMO.cpt out.cpt")
os.system("cp TOMO_half.cpt out.cpt")
os.system("cp TEMP.cpt out2.cpt")


# Calculating the grid files
for z in range(1):
        dz=float(z)
        print "Generating a slice for grid for depth ", dz, "km"
	
	XY=' -Xa'+Xs[0]+" -Ya"+Ys[0]+" "
        XY2=' -Xa'+Xs[0]+" -Ya"+Ys[1]+" "
        XY3=' -Xa'+Xs[0]+" -Ya"+Ys[2]+" "
        grds=commands.getoutput('ls GridFiles/*.grd')
        grdlist=grds.split('\n')
        sampleline='newsample.xy'
	sampleline2='newsampleb.xy'
        sampleline3='newsamplec.xy'      
 
	for grd in grdlist:
                print "grd", grd
                ext=grd.split('out.')[1].split('.grd')[0]
                depth=ext
                print "depth =", depth, "km"
                z=str(1.-(float(depth)/RAD))
                os.system("grdtrack "+sampleline+" -G"+grd+" -V > "+depth+"_tmp.xy")
                os.system("awk '{print($1, -1*"+depth+", $3) } ' "+depth+"_tmp.xy > long1_"+depth+".xy")
                os.system("awk '{print($1, "+z+", $3) } ' "+depth+"_tmp.xy > Zlong1_"+z+".xy")
                os.system("rm   "+depth+"_tmp.xy")
                os.system("grdtrack "+sampleline2+" -G"+grd+" -V > "+depth+"_tmp.xy")
                os.system("awk '{print($1, -1*"+depth+", $3) } ' "+depth+"_tmp.xy > long_"+depth+".xy")
                os.system("awk '{print($1, "+z+", $3) } ' "+depth+"_tmp.xy > Zlong_"+z+".xy")
                os.system("rm   "+depth+"_tmp.xy")
                os.system("grdtrack "+sampleline3+" -G"+grd+" -V > "+depth+"_tmp.xy")
                os.system("awk '{print($1, -1*"+depth+", $3) } ' "+depth+"_tmp.xy > long2_"+depth+".xy")
                os.system("awk '{print($1, "+z+", $3) } ' "+depth+"_tmp.xy > Zlong2_"+z+".xy")
                os.system("rm   "+depth+"_tmp.xy")  
   		
        os.system("cat long1_*.xy > Longitude1.xy")
        os.system("rm long1_*.xy")
        os.system("cat Zlong1_*.xy > ZLongitude1.xy")
        os.system("rm Zlong1_*.xy")
        os.system("cat long_*.xy > Longitude.xy")
        os.system("rm long_*.xy")
        os.system("cat Zlong_*.xy > ZLongitude.xy")
        os.system("rm Zlong_*.xy")
        os.system("cat long2_*.xy > Longitude2.xy")
        os.system("rm long2_*.xy")
        os.system("cat Zlong2_*.xy > ZLongitude2.xy")
        os.system("rm Zlong2_*.xy")
	
        os.system("mkdir "+str(dz) )
        os.system("mv Longitude1.xy Longitude.xy Longitude2.xy ZLongitude1.xy ZLongitude.xy ZLongitude2.xy  "+str(dz) )

        # ================================================================================
        # Find bounds and make a grid file for slice 1
        # ================================================================================
        mnmx=commands.getoutput('minmax '+str(dz)+'/ZLongitude1.xy').split('\t')
        xs=mnmx[1].split('<')[1]
        ys=mnmx[2].split('<')[1]
        ts=mnmx[3].split('<')[1]
        xmn=float(xs.split('/')[0])
        xmx=float(xs.split('/')[1].split('>')[0])
        ymn=float(ys.split('/')[0])
        ymx=float(ys.split('/')[1].split('>')[0])
        tmn=float(ts.split('/')[0])
        tmx=float(ts.split('/')[1].split('>')[0])
        # DEFINE REGION 
        west=str(xmn)
        east=str(xmx)
        #south=str(ymn)
	south="0.65"
        north=str(ymx)
	print "west =",west, "east", east, "south", south, "north", north 
        region=' -R'+west+'/'+east+'/'+south+'/'+north+' '
        ang = float(west) + ( float(east) - float(west) ) / 2
        proj=' -JPa8c/'+str(ang)
        ticks=' -B20/0.1wEsN:."": '
        os.system("surface "+str(dz)+'/ZLongitude1.xy '+region+' -I0.1/0.005 -V -Gslice.grd -Lu1 ')
        os.system("grdimage "+region+proj+XY+" slice.grd "+ticks+" -Cout.cpt -K > tomo.ps ")
        os.system("psxy "+refsxy+" -Sc0.1 -G0/255/0 -W2 "+region+proj+XY+" -O -K -N >> tomo.ps ")
	os.system("psxy lon1_660.xy  "+region+proj+XY+" -M -V -O -K  >> tomo.ps ")
	
        # ================================================================================
        # Find bounds and make a grid file for slice 2
        # ================================================================================
        mnmx=commands.getoutput('minmax '+str(dz)+'/ZLongitude.xy').split('\t')
        xs=mnmx[1].split('<')[1]
        ys=mnmx[2].split('<')[1]
        ts=mnmx[3].split('<')[1]
        xmn=float(xs.split('/')[0])
        xmx=float(xs.split('/')[1].split('>')[0])
        ymn=float(ys.split('/')[0])
        ymx=float(ys.split('/')[1].split('>')[0])
        tmn=float(ts.split('/')[0])
        tmx=float(ts.split('/')[1].split('>')[0])
        # DEFINE REGION 
        west=str(xmn)
        east=str(xmx)
        south='0.65'
        north=str(ymx)
        region=' -R'+west+'/'+east+'/'+south+'/'+north+' '
        ang = float(west) + ( float(east) - float(west) ) / 2
        proj=' -JPa8c/'+str(ang)
        ticks=' -B20/0.1wEsN:."": '
        os.system("surface "+str(dz)+'/ZLongitude.xy '+region+' -I0.1/0.005 -V -Gslice.grd -Lu1 ')
        os.system("grdimage "+region+proj+XY2+" slice.grd "+ticks+" -Cout.cpt -O -K >> tomo.ps ")
        os.system("psxy "+refsxyb+" -Sc0.1 -G255/0/0 -W2 "+region+proj+XY2+" -O -K -N >> tomo.ps ")
	os.system("psxy lon660.xy  "+region+proj+XY2+" -M -V -O -K  >> tomo.ps ")
        # ================================================================================
        # Find bounds and make a grid file for slice 3
        # ================================================================================
        mnmx=commands.getoutput('minmax '+str(dz)+'/ZLongitude2.xy').split('\t')
        xs=mnmx[1].split('<')[1]
        ys=mnmx[2].split('<')[1]
        ts=mnmx[3].split('<')[1]
        xmn=float(xs.split('/')[0])
        xmx=float(xs.split('/')[1].split('>')[0])
        ymn=float(ys.split('/')[0])
        ymx=float(ys.split('/')[1].split('>')[0])
        tmn=float(ts.split('/')[0])
        tmx=float(ts.split('/')[1].split('>')[0])
        # DEFINE REGION
        west=str(xmn)
        east=str(xmx)
        south='0.65'
        north=str(ymx)
        region=' -R'+west+'/'+east+'/'+south+'/'+north+' '
        ang = float(west) + ( float(east) - float(west) ) / 2
        proj=' -JPa8c/'+str(ang)
        ticks=' -B20/0.1wEsN:."": '
        os.system("surface "+str(dz)+'/ZLongitude2.xy '+region+' -I0.1/0.005 -V -Gslice.grd -Lu1 ')
        os.system("grdimage "+region+proj+XY3+" slice.grd "+ticks+" -Cout.cpt -O -K >> tomo.ps ")
        os.system("psxy "+refsxyc+" -Sc0.1 -G0/0/255 -W2 "+region+proj+XY3+" -O -K -N >> tomo.ps ")
	os.system("psxy lon660.xy  "+region+proj+XY3+" -M -V -O -K  >> tomo.ps ")

# Plot scale bar for tomography
position=' -Xa3.5   -Ya1.6  '
scalepar="-D1.4/0.1/6.0c/0.2h"
os.system(" psscale -Cout.cpt "+scalepar+"   -B0.5:"":/:"+'"dVp %"'+":  "+position+"  -K -V -O >> tomo.ps")

# ==============================================================
# Plotting SAm forward model results
# =============================================================
XY=' -Xa'+Xs[1]+" -Ya"+Ys[0]+" "
XY2=' -Xa'+Xs[1]+" -Ya"+Ys[1]+" "
XY3=' -Xa'+Xs[1]+" -Ya"+Ys[2]+" "
grds=commands.getoutput('ls SAm_Grids/*.grd')
grdlist=grds.split('\n')
sampleline_r='newsample_r.xy'
sampleline2_r='newsampleb_r.xy'
sampleline3_r='newsamplec_r.xy'

for grd in grdlist:
                print "grd", grd
                ext=grd.split('embd.'+str(timestep)+'.')[1].split('.grd')[0]
                print ext
		depth=ext.split('.')[2]
                print "depth =", depth, "km"
				
                z=str(1.-(float(depth)/RAD))
                os.system("grdtrack "+sampleline_r+" -G"+grd+" -V > "+depth+"_tmp.xy")
                os.system("awk '{print($1, -1*"+depth+", $3) } ' "+depth+"_tmp.xy > long1_"+depth+".xy")
                os.system("awk '{print($1, "+z+", $3) } ' "+depth+"_tmp.xy > Zlong1_"+z+".xy")
                os.system("rm   "+depth+"_tmp.xy")
                os.system("grdtrack "+sampleline2_r+" -G"+grd+" -V > "+depth+"_tmp.xy")
                os.system("awk '{print($1, -1*"+depth+", $3) } ' "+depth+"_tmp.xy > long_"+depth+".xy")
                os.system("awk '{print($1, "+z+", $3) } ' "+depth+"_tmp.xy > Zlong_"+z+".xy")
                os.system("rm   "+depth+"_tmp.xy")
                os.system("grdtrack "+sampleline3_r+" -G"+grd+" -V > "+depth+"_tmp.xy")
                os.system("awk '{print($1, -1*"+depth+", $3) } ' "+depth+"_tmp.xy > long2_"+depth+".xy")
                os.system("awk '{print($1, "+z+", $3) } ' "+depth+"_tmp.xy > Zlong2_"+z+".xy")
                os.system("rm   "+depth+"_tmp.xy")

os.system("cat long1_*.xy > Longitude1.xy")
os.system("rm long1_*.xy")
os.system("cat Zlong1_*.xy > ZLongitude1.xy")
os.system("rm Zlong1_*.xy")
os.system("cat long_*.xy > Longitude.xy")
os.system("rm long_*.xy")
os.system("cat Zlong_*.xy > ZLongitude.xy")
os.system("rm Zlong_*.xy")
os.system("cat long2_*.xy > Longitude2.xy")
os.system("rm long2_*.xy")
os.system("cat Zlong2_*.xy > ZLongitude2.xy")
os.system("rm Zlong2_*.xy")

os.system("mkdir SAm_F")
os.system("mv Longitude1.xy Longitude.xy Longitude2.xy ZLongitude1.xy ZLongitude.xy ZLongitude2.xy  SAm_F" )

# ================================================================================
# Find bounds and make a grid file for slice 1
# ================================================================================
mnmx=commands.getoutput('minmax SAm_F/ZLongitude1.xy').split('\t')
xs=mnmx[1].split('<')[1]
ys=mnmx[2].split('<')[1]
ts=mnmx[3].split('<')[1]
xmn=float(xs.split('/')[0])
xmx=float(xs.split('/')[1].split('>')[0])
ymn=float(ys.split('/')[0])
ymx=float(ys.split('/')[1].split('>')[0])
tmn=float(ts.split('/')[0])
tmx=float(ts.split('/')[1].split('>')[0])
# DEFINE REGION
west=str(xmn)
east=str(xmx)
#south=str(ymn)
south="0.65"
north=str(ymx)
print "west =",west, "east", east, "south", south, "north", north
region=' -R'+west+'/'+east+'/'+south+'/'+north+' '
ang = float(west) + ( float(east) - float(west) ) / 2
proj=' -JPa8c/'+str(ang)
ticks=' -B20/0.1wEsN:."": '
os.system('surface SAm_F/ZLongitude1.xy '+region+' -I0.1/0.005 -V -Gslice.grd -Lu1 ')
os.system("grdimage "+region+proj+XY+" slice.grd "+ticks+" -Cout2.cpt -O -K >> tomo.ps ")
os.system("psxy "+refsxy+" -Sc0.1 -G0/255/0 -W2 "+region+proj+XY+" -O -K -N >> tomo.ps ")
os.system("psxy lon1_660.xy  "+region+proj+XY+" -M -V -O -K  >> tomo.ps ")

# ================================================================================
# Find bounds and make a grid file for slice 2
# ================================================================================
mnmx=commands.getoutput('minmax SAm_F/ZLongitude.xy').split('\t')
xs=mnmx[1].split('<')[1]
ys=mnmx[2].split('<')[1]
ts=mnmx[3].split('<')[1]
xmn=float(xs.split('/')[0])
xmx=float(xs.split('/')[1].split('>')[0])
ymn=float(ys.split('/')[0])
ymx=float(ys.split('/')[1].split('>')[0])
tmn=float(ts.split('/')[0])
tmx=float(ts.split('/')[1].split('>')[0])
# DEFINE REGION
west=str(xmn)
east=str(xmx)
south='0.65'
north=str(ymx)
region=' -R'+west+'/'+east+'/'+south+'/'+north+' '
ang = float(west) + ( float(east) - float(west) ) / 2
proj=' -JPa8c/'+str(ang)
ticks=' -B20/0.1wEsN:."": '
os.system('surface SAm_F/ZLongitude.xy '+region+' -I0.1/0.005 -V -Gslice.grd -Lu1 ')
os.system("grdimage "+region+proj+XY2+" slice.grd "+ticks+" -Cout2.cpt -O -K >> tomo.ps ")
os.system("psxy "+refsxyb+" -Sc0.1 -G255/0/0 -W2 "+region+proj+XY2+" -O -K -N >> tomo.ps ")
os.system("psxy lon660.xy  "+region+proj+XY2+" -M -V -O -K  >> tomo.ps ")

# ================================================================================
# Find bounds and make a grid file for slice 3
# ================================================================================
mnmx=commands.getoutput('minmax SAm_F/ZLongitude2.xy').split('\t')
xs=mnmx[1].split('<')[1]
ys=mnmx[2].split('<')[1]
ts=mnmx[3].split('<')[1]
xmn=float(xs.split('/')[0])
xmx=float(xs.split('/')[1].split('>')[0])
ymn=float(ys.split('/')[0])
ymx=float(ys.split('/')[1].split('>')[0])
tmn=float(ts.split('/')[0])
tmx=float(ts.split('/')[1].split('>')[0])
# DEFINE REGION
west=str(xmn)
east=str(xmx)
south='0.65'
north=str(ymx)
region=' -R'+west+'/'+east+'/'+south+'/'+north+' '
ang = float(west) + ( float(east) - float(west) ) / 2
proj=' -JPa8c/'+str(ang)
ticks=' -B20/0.1wEsN:."": '
os.system('surface SAm_F/ZLongitude2.xy '+region+' -I0.1/0.005 -V -Gslice.grd -Lu1 ')
os.system("grdimage "+region+proj+XY3+" slice.grd "+ticks+" -Cout2.cpt -O -K >> tomo.ps ")
os.system("psxy "+refsxyc+" -Sc0.1 -G0/0/255 -W2 "+region+proj+XY3+" -O -K -N >> tomo.ps ")
os.system("psxy lon660.xy  "+region+proj+XY3+" -M -V -O -K  >> tomo.ps ")

# Plot scale bar for temperature
position=' -Xa12.5   -Ya1.6  '
scalepar="-D1.4/0.1/6.0c/0.2h"
os.system(" psscale -Cout2.cpt "+scalepar+"   -B0.5:"":/:"+'"Temperature"'+":  "+position+"  -K -V -O >> tomo.ps")

# ============================================================
# Plotting the row names 
# ============================================================
# In LT --> x from left, y from bottom, size, angle, fontno, justify, text
LT=open("label.txt","w")
txt1='MITP08'
print >> LT, '15.5 15.0 20 0 0 1 '+txt1
LT.close()
os.system("pstext label.txt -JX25c -R0/100/0/20  -O -K  -V -G0/0/0  -W255/255/255  >>   tomo.ps")

# In LT --> x, y, size, angle, fontno, justify, text
LT=open("label.txt","w")
txt1='Slab 23E'
print >> LT, '52 15.0 20 0 0 1 '+txt1
LT.close()
os.system("pstext label.txt -JX25c -R0/100/0/20  -O -K  -V -G0/0/0  -W255/255/255  >>   tomo.ps")

# In LT --> x, y, size, angle, fontno, justify, text
LT=open("label.txt","w")
txt1='Locations'
print >> LT, '88 15.0 20 0 0 1 '+txt1
LT.close()
os.system("pstext label.txt -JX25c -R0/100/0/20  -O -K  -V -G0/0/0  -W255/255/255  >>   tomo.ps")

# ============================================================
#       Plot map showing location of slices
# ============================================================
#P=' -JS140/-30/6c '
P='-Jm0.05c '
#R = ' -R-90/0/-60/15 ' #west, east, south, north
R = ' -R90/180/-60/0 ' #west, east, south, north
ticks=' -Ba30f30Wesn:."": '

off=" -Xa8.2i  -Ya13.5 "
os.system("pscoast -W  -V -I1 -N1  -K -O -V "+P+R+ticks+off+"  >> tomo.ps ")
os.system("psxy BaseMapData/bird_boundaries -V -O -K -M  "+P+R+ticks+off+" >>tomo.ps")
os.system("psxy BaseMapData/bird_trench_LUR_all -W3 -O -K -M -Sf0.2/0.07rt -G0/0/0 "+P+R+ticks+off+" >> tomo.ps")
os.system("psxy newsample.xy -W4  "+P+R+ticks+off+" -O -K  >>tomo.ps")
os.system("psxy "+refs+" -Sc0.08 -G0/255/0 -W0/0/0 "+P+R+ticks+off+" -O -K  >>tomo.ps")

off=" -Xa8.2i  -Ya8.0 "
os.system("pscoast -W  -V -I1 -N1  -K -O -V "+P+R+ticks+off+"  >> tomo.ps ")
os.system("psxy BaseMapData/bird_boundaries -V -O -K -M  "+P+R+ticks+off+" >>tomo.ps")
os.system("psxy BaseMapData/bird_trench_LUR_all -W3 -O -K -M -Sf0.2/0.07rt -G0/0/0 "+P+R+ticks+off+" >> tomo.ps")
os.system("psxy newsampleb.xy -W4  "+P+R+ticks+off+" -O -K  >>tomo.ps")
os.system("psxy "+refsb+" -Sc0.08 -G255/0/0 -W0/0/0 "+P+R+ticks+off+" -O -K  >>tomo.ps")

off=" -Xa8.2i  -Ya2.5 "
os.system("pscoast -W  -V -I1 -N1  -K -O -V "+P+R+ticks+off+"  >> tomo.ps ")
os.system("psxy BaseMapData/bird_boundaries -V -O -K -M  "+P+R+ticks+off+" >>tomo.ps")
os.system("psxy BaseMapData/bird_trench_LUR_all -W3 -O -K -M -Sf0.2/0.07rt -G0/0/0 "+P+R+ticks+off+" >> tomo.ps")
os.system("psxy newsamplec.xy -W4  "+P+R+ticks+off+" -O -K  >>tomo.ps")
os.system("psxy "+refsc+" -Sc0.08 -G0/0/255 -W0/0/0 "+P+R+ticks+off+" -O -K  >>tomo.ps")

