#!/usr/bin/env python

# ============================================================
# LOAD PYTHON MODULES
# ============================================================
import sys, string, os, math, commands, random
import CitcomParser
import Core_Citcom, Core_Util
import Core_GMT, Core_File
Core_Citcom.verbose = True
Core_GMT.verbose = True
import ROTATION_FUNCTIONS
# ======================================================================
#	IMPORT PLOTTING MODULES
# ======================================================================
import pylab, numpy
from pylab import randn, hist, matplotlib
import matplotlib.pyplot as P
from matplotlib import collections, axes, transforms
from matplotlib.colors import colorConverter
import numpy as N
# ======================================================================
#	IMPORT CITCOM EXTRACTING MODULES
# ======================================================================
import CitcomParser
import Core_Citcom, Core_Util
import Core_GMT, Core_File
Core_Citcom.verbose = True
Core_GMT.verbose = True

# ============================================================
# SET GMT PARAMS
# ============================================================
os.system("gmtset LABEL_FONT_SIZE=12p")
os.system("gmtset HEADER_FONT_SIZE=12p")

# ============================================================
# XY DATA TO PLOT
# ============================================================
plateaus='/home/lydia/OBSERVED_DYNAM_TOPO_MAP/datafiles/QueenslandPlateau.xy'
plateaus2='/home/lydia/OBSERVED_DYNAM_TOPO_MAP/datafiles/Marion_Shelf.xy'

# ============================================================
# TRACK SAMPLE 7
# ============================================================
#refs='/home/kara/Tomography_CitcomS/dependencies/aad_test_green_spots.xy'
#refsxy='/home/kara/Tomography_CitcomS/dependencies/aad_test_xsect_marker.xy'
#sample='/home/kara/Tomography_CitcomS/dependencies/aad_test.dat'

#sampleb='/home/kara/Tomography_CitcomS/dependencies/basins_test1.dat'
#refsxyb='/home/kara/Tomography_CitcomS/dependencies/linec_xsect_marker.xy'
#refsb='/home/kara/Tomography_CitcomS/dependencies/basins_test1_red_spots.xy'

sample='/home/kara/Tomography_CitcomS/dependencies/basins_north.dat'
refsxy='/home/kara/Tomography_CitcomS/dependencies/linec_xsect_marker.xy'
refs='/home/kara/Tomography_CitcomS/dependencies/basins_north_green_spots.xy'

refsb='/home/kara/Tomography_CitcomS/dependencies/basins_south_red_spots.xy'
refsxyb='/home/kara/Tomography_CitcomS/dependencies/linec_xsect_marker.xy'
sampleb='/home/kara/Tomography_CitcomS/dependencies/basins_south.dat'

#sample_rotnorth='/home/kara/Tomography_CitcomS/dependencies/aad_rot.dat'
#sample_rotnorthb='/home/kara/Tomography_CitcomS/dependencies/basins_rot.dat'
sample_rotnorth='/home/kara/Tomography_CitcomS/dependencies/basins_north_rot.dat'
sample_rotnorthb='/home/kara/Tomography_CitcomS/dependencies/basins_south_rot.dat'

# ============================================================
#	FILL OUT THE SAMPLE LINE
# ============================================================
os.system("sample1d "+sample+" -Fl -I0.01 -M -V > newsample.xy")
os.system("sample1d "+sampleb+" -Fl -I0.01 -M -V > newsampleb.xy")
os.system("sample1d "+sample_rotnorth+" -Fl -I0.01 -M -V > newsample_r.xy")
os.system("sample1d "+sample_rotnorthb+" -Fl -I0.01 -M -V > newsampleb_r.xy")
# ============================================================
#	XY FILE OF TRANSITION ZONE
# ============================================================
dep660='/home/lydia/GPLATES/New_gplates/Cookbook_Models/CLOSE_SECTIONS_NE/datafiles/600_transition.xy'

os.system("awk '{print($1, 0.8964) } ' newsampleb.xy > lon660.xy")
os.system("awk '{print($1, 0.8964) } ' newsample.xy > lon1_660.xy")
#os.system("awk '{print($2, 0.8964) } ' newsample.xy > lat660.xy")

# NON-DIMENSIONAL DEPTH
CMB=2889.
RAD=6371.

# ============================================================
# ROTATION FILES AND PROGRAMS
# ============================================================
CSFILE='/home/lydia/Lydia_CVS_Files/Make_Movie_From_Gplates/global04cs.dat'
ROTFILE='/home/lydia/GPLATES/ROTATED_COASTLINES/Global_EarthByte_20070427.rot'
ROTPROG='/home/lydia/Lydia_CVS_Files/Make_Movie_From_Gplates/rotdat.pl'
pole= '0.0 225 37.5'
equator='0.0 225 -37.5'	
rotpts='rotpts'

pp_bird='/home/lydia/GPLATES/New_gplates/Make_Craton_Tracers/PLOT_PRESENT/bird_boundaries'
subductions='/home/datalib/Plate_Boundaries/Tape_sub_zones/bird_trench_LUR_all'
# =================================================================================
#	COLUMN GEOMETRY
# =================================================================================
#Ys=['6.8i','6.8i']
#Xs=['0.5i','3.8i']

#Ysa=['4.8i','2.9i','1.0i']
#Xsa=['0.5i','3.8i','6.7i']

#Columns for profiles that extend to CMB
Ys=['18.8','18.8']
Xs=['0.7','10.0']

Ysa=['12.7','7.7','2.5']
Xsa=['0.7','9.7','14.7']




# =================================================================================
#	SELECTED GEODYNAMIC MODEL FILES
# =================================================================================
# 	IMPORTANT
# This is the time in millions of years that you want to visualise. This must *exactly*
# match the time step the end of your simulation, i.e. endtime.
# Note that the initial time in your model is specified in ROTATIONS_FUNCTIONS.py line 265

buffer = 100
#mtimes=['3']   # i.e. 3 Ma
#endtime=4400+buffer

mtimes=['1']
endtime = 3500+buffer

#mname='M9_AMBIENT_0.05'
mname='Slab_23E/'
grids='GRIDS/'
#direct='/net/weka/backup/lydia/M50s/ANT_HOT/'
#direct='/home/alinah/Australia/aus_data/'
direct='/home/kara/Tomography_CitcomS/aus_data/'
modelcap=direct+mname+'embd.cap00.'
modelcapdir=direct+mname
MODEL_GRDS= modelcapdir+grids
print "Grid file directory =", MODEL_GRDS

# =================================================================================
# 			FIND ALL TIMES AND STEPS FOR THIS MODEL
#    This stage runs through the embd.time file and works out the time in Ma for each step
#    The last timestep (end time) is used for the tomography visulisation
#    ntimes = time in Ma; nsteps = model step
# =================================================================================
(times,steps)=ROTATION_FUNCTIONS.findsteps(endtime,modelcapdir)
ntimes=[]
nsteps=[]
for t in range(len(times)):
	time=times[t]
	print "time = ", time, "in Ma"
	step=steps[t]
	#print "step", step
	#print "mtimes", mtimes
	for n in mtimes:
		print "time", times, "n", n
		if float(time) == float(n):
			ntimes.append(time)
			nsteps.append(step)
#1/0 - First time this script is run un-comment this out so you can see what the real time is at the last timestep
# =================================================================================
# SET UP SOME PLOT PROPERTIES
# =================================================================================
P='-JPa8c/-27.5097098  '
R=' -R-55.0469/0.0274804/0.65/0.993094 '
#R=' -R-55.0469/0.0274804/0.8/0.993094 '
ticks='  -B20/0.1wE:."": '
#ticks='  -B20/0.1wEsN:."": '
#os.system("cp ../EXTRACT_ROT_ALL/COLOR/surface.cpt surface.cpt")
os.system("cp COLOR/surface.cpt surface.cpt")

# =================================================================================
# 			Begin plot
# =================================================================================
os.system("psbasemap  "+P+R+ticks+" -Xa"+Xs[0]+" -Ya"+Ys[0]+" -P -K > tomo.ps")

# =================================================================================
# PLOT TEMPERATURE SLICES IN COLUMNS
# =================================================================================
#os.system("cp dependencies/seis_hotreduced.cpt out.cpt")
#os.system("cp dependencies/seis_hotreduced_red_alt.cpt out.cpt")
os.system("cp dependencies/alina.cpt out.cpt")
#os.system("cp dependencies/seis_hotreduced2.cpt out.cpt")

from pylab import flipud
nntimes=flipud(ntimes)
nnsteps=flipud(nsteps)
print "nntimes", nntimes
print "nnsteps", nnsteps

# NON-DIMENSIONAL DEPTH
CMB=2889.
RAD=6371.

"""
#This part of the code can be blanked out once you have your grid files for endtime
# =================================================================================
# GENERATIME GRID FILES FOR ALL DEPTHS AT ENDTIME
# =================================================================================
print "Generating grids at each depth for specified endtime =", nntimes, "Ma"
# 1: Find exact depths
Rad2Deg = 180.0/math.pi
timestep=endtime-buffer

coordfile=open(modelcapdir+"embd.cap00."+str(timestep),'r')
print "coordfile", coordfile
c1=coordfile.readlines()
z_vals = []
for i in range(65):
	#print c1[i+1]
	z=(c1[i+1].split(' ')[2].split('\n')[0])
	#print z
	z_vals.append(z)
depth=0
for z in range(len(z_vals)):
	slice=open('slice.xyz','w')
	dz=float(z_vals[z])
	print "Calculating grid for depth ", dz
	coordfile2=open(modelcapdir+"embd.cap00."+str(timestep),'r')
	
        c2 = coordfile2.readlines()
	for i in range (4293186-1):
		#print i
		z=(c2[i+1].split(' ')[2].split('\n')[0])
		if float(z) == dz:
			slice.write(str(float(c2[i+1].split(' ')[1].split('\n')[0])*Rad2Deg)+' '+str(90. - float(c2[i+1].split(' ')[0].split('\n')[0])*Rad2Deg)+' '+(c2[i+1].split(' ')[6].split('\n')[0])+' \n')
	slice.close()
	os.system("surface -V -R100/187/-47.5/47.5 -I0.2/0.2 slice.xyz -Lu1 -Ll0 -Gout.grd -T0.1")
	#os.system("surface -V -R100/187/-75/10 -I0.2/0.2 slice.xyz -Lu1 -Ll0 -Gout.grd -T0.1")
	# -V = Verbose; -I = inc; -Lu = Upper bound for z, -Ll = Lower bound for z, -T tension factor
	print "depth", dz
        realdepth = int((1.-dz)*RAD)
	print "dimensionalised depth", realdepth 	
	os.system("mv out.grd  embd."+str(timestep)+"."+str(depth)+"."+str(realdepth)+".grd")
	os.system("rm slice.xyz")
	depth+=1
	coordfile2.close()
        os.system("mv *.grd  GRIDS")

os.system("mv GRIDS/*.grd  "+MODEL_GRDS+"")
"""

for mme in range(len(nnsteps)):
	ntime=nntimes[mme]
	modtime=nnsteps[mme]
	print "modtime = ", modtime
	XY=' -Xa'+Xs[0]+" -Ya"+Ys[0]+" "
	XY2=' -Xa'+Xs[1]+" -Ya"+Ys[0]+" "
	grds=commands.getoutput('ls '+MODEL_GRDS+'*.grd')
	grdlist=grds.split('\n')
	sampleline_r='newsample_r.xy'
	sampleline2_r='newsampleb_r.xy'
	sampleline='newsample.xy'
	sampleline2='newsampleb.xy'

	
	for grd in grdlist:
		print "hello"
		print "grd", grd
		ext=grd.split('embd.'+str(modtime)+'.')[1].split('.grd')[0]
		print "ext", ext
		depth=ext.split('.')[1]
		print "depth =", depth, "km"
		z=str(1.-(float(depth)/RAD))
		os.system("grdtrack "+sampleline_r+" -G"+grd+" -V > "+depth+"_tmp.xy")
		os.system("awk '{print($1, -1*"+depth+", $3) } ' "+depth+"_tmp.xy > long1_"+depth+".xy")
		os.system("awk '{print($1, "+z+", $3) } ' "+depth+"_tmp.xy > Zlong1_"+z+".xy")
		os.system("rm 	"+depth+"_tmp.xy")
		os.system("grdtrack "+sampleline2_r+" -G"+grd+" -V > "+depth+"_tmp.xy")
		os.system("awk '{print($1, -1*"+depth+", $3) } ' "+depth+"_tmp.xy > long_"+depth+".xy")
		os.system("awk '{print($1, "+z+", $3) } ' "+depth+"_tmp.xy > Zlong_"+z+".xy")
		os.system("rm 	"+depth+"_tmp.xy")
	os.system("cat long1_*.xy > Longitude1.xy")
	os.system("rm long1_*.xy")
	os.system("cat Zlong1_*.xy > ZLongitude1.xy")
	os.system("rm Zlong1_*.xy")
	os.system("cat long_*.xy > Longitude.xy")
	os.system("rm long_*.xy")
	os.system("cat Zlong_*.xy > ZLongitude.xy")
	os.system("rm Zlong_*.xy")
	os.system("rm "+str(modtime)+'/* ')
	os.system("mkdir "+str(modtime) )
	os.system("mv Longitude1.xy Longitude.xy ZLongitude1.xy ZLongitude.xy "+str(modtime) )
	# ================================================================================
	# FIND BOUNDS AND MAKE GRID FILE FOR 1st LINE
	# ================================================================================
	mnmx=commands.getoutput('minmax '+str(modtime)+'/ZLongitude1.xy').split('\t')	
	xs=mnmx[1].split('<')[1]
	ys=mnmx[2].split('<')[1]
	ts=mnmx[3].split('<')[1]
	xmn=float(xs.split('/')[0])
	xmx=float(xs.split('/')[1].split('>')[0])
	ymn=float(ys.split('/')[0])
	ymx=float(ys.split('/')[1].split('>')[0])
	tmn=float(ts.split('/')[0])
	tmx=float(ts.split('/')[1].split('>')[0])
	# DEFINE REGION 
	west=str(xmn)
	east=str(xmx)
	south='0.65'
	#south='0.8'
	north=str(ymx)
	region=' -R'+west+'/'+east+'/'+south+'/'+north+' '
	ang = float(west) + ( float(east) - float(west) ) / 2
	proj=' -JPa8c/'+str(ang)
	ticks=' -B20/0.1wEsN:."": '
	os.system("surface "+str(modtime)+'/ZLongitude1.xy '+region+' -I0.1/0.005 -V -Gslice.grd -Lu1 ')
	#os.system("grdimage "+region+proj+XY+" slice.grd -Cout.cpt -O -K >> tomo.ps ")
	os.system("grdimage "+region+proj+XY+" slice.grd "+ticks+" -Cout.cpt -O -P -K >> tomo.ps ")	
	os.system("psxy "+refsxy+" -Sc0.1 -G0/255/0 -W2 "+region+proj+XY+" -O -P -K -N >> tomo.ps ")
	os.system("psxy lon1_660.xy  "+region+proj+XY+" -M -V -O -P -K  >> tomo.ps ")
	
	# ================================================================================
	# FIND BOUNDS AND MAKE GRID FILE FOR 2nd LINE
	# ================================================================================
	mnmx=commands.getoutput('minmax '+str(modtime)+'/ZLongitude.xy').split('\t')	
	xs=mnmx[1].split('<')[1]
	ys=mnmx[2].split('<')[1]
	ts=mnmx[3].split('<')[1]
	xmn=float(xs.split('/')[0])
	xmx=float(xs.split('/')[1].split('>')[0])
	ymn=float(ys.split('/')[0])
	ymx=float(ys.split('/')[1].split('>')[0])
	tmn=float(ts.split('/')[0])
	tmx=float(ts.split('/')[1].split('>')[0])
	# DEFINE REGION 
	west=str(xmn)
	east=str(xmx)
	south='0.65'
	#south='0.8'
	north=str(ymx)
	region=' -R'+west+'/'+east+'/'+south+'/'+north+' '
	ang = float(west) + ( float(east) - float(west) ) / 2
	proj=' -JPa8c/'+str(ang)
	ticks=' -B20/0.1wEsN:."": '
	os.system("surface "+str(modtime)+'/ZLongitude.xy '+region+' -I0.1/0.005 -V -Gslice.grd -Lu1 ')
	os.system("grdimage "+region+proj+XY2+" slice.grd "+ticks+" -Cout.cpt -O -P -K >> tomo.ps ")	
	os.system("psxy "+refsxyb+" -Sc0.1 -G255/0/0 -W2 "+region+proj+XY2+" -O -P -K -N >> tomo.ps ")
	os.system("psxy lon660.xy  "+region+proj+XY2+" -M -V -O -P -K  >> tomo.ps ")

# ============================================================
# 	GET THE TOMOGRAPHY COMPARISONS
# ============================================================
# FOR THE LONGITUDE1 FILE
mnmx_lon=commands.getoutput('minmax '+sampleline+'').split('\t')
regiona=' -R100/190/-65/5 '

# FOR THE LONGITUDE FILE
mnmx_lon=commands.getoutput('minmax '+sampleline2+'').split('\t')
regionb=' -R100/190/-65/5 '

# ============================================================
# CREATE AN XY LIST FOR TOMO
# ============================================================	
# These three are my favourite S-wave models for Aus.
#tomodira='/net/weka/backup/lydia/TOMO/Models/s20rts/'
#namea='s20rts'
#tomodirb='/net/weka/backup/lydia/TOMO/Models/Simmons_07/'
#nameb='Simmons_07'
#tomodirc='/net/weka/backup/lydia/TOMO/Models/ngrand/'
#namec='ngrand'

#tomodirb='/net/weka/backup/lydia/TOMO/Models/sb4l18/'
#nameb='sb4l18'
#tomodirc='/net/weka/backup/lydia/TOMO/Models/Li/'
#namec='Li'
#tomodirc='/net/weka/backup/lydia/TOMO/Models/Simmons_07/'
#namec='Simmons_07'

#tomodira='/net/weka/backup/lydia/TOMO/Models/ngrand/'
#namea='ngrand'
#tomodirb='/net/weka/backup/lydia/TOMO/Models/saw24b16/'
#nameb='saw24b16'
#tomodirc='/net/weka/backup/lydia/TOMO/Models/Li/'
#namec='Li'

#tomodira='/net/weka/backup/lydia/TOMO/Models/s362/'
#namea='s362'
#tomodirb='/net/weka/backup/lydia/TOMO/Models/Montelli06_S/'
#nameb='Montelli06_S'
#tomodirc='/net/weka/backup/lydia/TOMO/Models/Montelli06_P/'
#namec='Montelli06_P'

#The first two are P-wave models, with an S-wave for comparison
tomodira='/net/weka/backup/lydia/TOMO/Models/Li/'
namea='Li'
tomodirb='/net/weka/backup/lydia/TOMO/Models/Montelli06_P/'
nameb='Montelli06_P'
tomodirc='/net/weka/backup/lydia/TOMO/Models/s20rts/'
namec='s20rts'

tomos=[tomodira+namea, tomodirb+nameb,tomodirc+namec]
tomo_names=[namea,nameb,namec]

for t in range(len(tomos)):
	tomo=tomos[t]
	xyfiles=commands.getoutput('ls '+tomo+'_*.xy')
	xylist=xyfiles.split('\n')
	name=tomo_names[t]
	sampleline='newsample.xy'
	sampleline2='newsampleb.xy'
	# ============================================================
	#  FOR EVERY XY EXTRACT THE TRACK YOU WANT
	# ============================================================
	# THIS IS TIME CONSUMING SO IT IS COMMENTED OUT
	#for xy in xylist:
		#ext=xy.split('/net/weka/backup/lydia/TOMO/Models/'+name+'/'+name+'_')[1].split('.xy')[0]
		#depth=ext
		#z=str(1-(float(depth)/RAD))
		#os.system("surface "+xy+regiona+" -I0.15/0.15 -Gtomo_"+depth+".grd ")
		#os.system("makecpt -Crainbow -T-1/1/0.1 -D > Tomo.cpt")
		#os.system("grdtrack "+sampleline+" -Gtomo_"+depth+".grd -V > tomo1_"+depth+"_tmp.xy")
		#os.system("awk '{print($1, "+z+", $3) } ' tomo1_"+depth+"_tmp.xy > Zlong1_"+z+".xy")
		#os.system("rm 	tomo1_"+depth+"_tmp.xy")
		#os.system("surface "+xy+regionb+" -I0.15/0.15 -Gtomo_"+depth+".grd ")
		#os.system("grdtrack "+sampleline2+" -Gtomo_"+depth+".grd -V > tomo_"+depth+"_tmp.xy")
		#os.system("awk '{print($1, "+z+", $3) } ' tomo_"+depth+"_tmp.xy > Zlong_"+z+".xy")
		#os.system("rm tomo_"+depth+"_tmp.xy")
	#os.system("cat Zlong1_*.xy > "+name+"Tomo_Longitude1.xy")
	#os.system("mv "+name+"Tomo_Longitude1.xy TOMOS/")
	#os.system("rm Zlong1_*.xy")
	#os.system("cat Zlong_*.xy > "+name+"Tomo_Longitude.xy")
	#os.system("mv "+name+"Tomo_Longitude.xy TOMOS/")
	#os.system("rm Zlong_*.xy")

# =================================================================================
# PLOT TOMOGRAPHY SLICES IN COLUMNS
# =================================================================================
os.system("cp dependencies/TOMO.cpt Tomo.cpt")
#os.system("cp dependencies/TOMO_half.cpt Tomo.cpt")

TOMO_LONGS1=['TOMOS/'+namea+"Tomo_Longitude1.xy",'TOMOS/'+nameb+"Tomo_Longitude1.xy",'TOMOS/'+namec+"Tomo_Longitude1.xy"]
TOMO_LONGS=['TOMOS/'+namea+"Tomo_Longitude.xy",'TOMOS/'+nameb+"Tomo_Longitude.xy",'TOMOS/'+namec+"Tomo_Longitude.xy"]
#TOMO_LATS=['TOMOS/'+namea+"Tomo_Latitude.xy",'TOMOS/'+nameb+"Tomo_Latitude.xy",'TOMOS/'+namec+"Tomo_Latitude.xy"]

for me in range(len(tomos)):
	TOMO_LONG1=TOMO_LONGS1[me]
	TOMO_LONG=TOMO_LONGS[me]
	#TOMO_LAT=TOMO_LATS[me]
	XY=' -Xa'+Xsa[0]+" -Ya"+Ysa[me]+" "
	XY2=' -Xa'+Xsa[1]+" -Ya"+Ysa[me]+" "
	# ================================================================================
	# FIND BOUNDS AND MAKE GRID FILE FOR 1st LINE
	# ================================================================================
	#mnmx=commands.getoutput('minmax '+TOMO_LAT).split('\t')	
	#xs=mnmx[1].split('<')[1]
	#ys=mnmx[2].split('<')[1]
	#ts=mnmx[3].split('<')[1]
	#xmn=float(xs.split('/')[0])
	#xmx=float(xs.split('/')[1].split('>')[0])
	#ymn=float(ys.split('/')[0])
	#ymx=float(ys.split('/')[1].split('>')[0])
	#tmn=float(ts.split('/')[0])
	#tmx=float(ts.split('/')[1].split('>')[0])
	# DEFINE REGION 
	#west=str(xmn)
	#east=str(xmx)
	#south='0.8'
	#north=str(ymx)
	#region=' -R'+west+'/'+east+'/'+south+'/'+north+' '
	#ang = float(west) + ( float(east) - float(west) ) / 2
	#proj=' -JPa8c/'+str(ang)
	#ticks=' -B20/0.1wEsN:."": '
	#os.system("surface "+TOMO_LAT+' '+region+' -I0.1/0.005 -V -Gslice.grd -Lu1 ')
	#os.system("grdimage "+region+proj+XY+" slice.grd "+ticks+" -CTomo.cpt -O -K >> tomo.ps ")
	#os.system("psxy "+refsxy+" -Sc0.1 -G0/255/0 -W2 "+region+proj+XY+" -O -K -N >> tomo.ps ")
	#os.system("psxy lat660.xy  "+region+proj+XY+" -M -V -O -K >> tomo.ps ")
	# ================================================================================
	# FIND BOUNDS AND MAKE GRID FILE FOR 1st LINE
	# ================================================================================
	mnmx=commands.getoutput('minmax '+TOMO_LONG1).split('\t')	
	xs=mnmx[1].split('<')[1]
	ys=mnmx[2].split('<')[1]
	ts=mnmx[3].split('<')[1]
	xmn=float(xs.split('/')[0])
	xmx=float(xs.split('/')[1].split('>')[0])
	ymn=float(ys.split('/')[0])
	ymx=float(ys.split('/')[1].split('>')[0])
	tmn=float(ts.split('/')[0])
	tmx=float(ts.split('/')[1].split('>')[0])
	# DEFINE REGION 
	west=str(xmn)
	east=str(xmx)
	south='0.65'
	#south='0.8'
	north=str(ymx)
	region=' -R'+west+'/'+east+'/'+south+'/'+north+' '
	ang = float(west) + ( float(east) - float(west) ) / 2
	proj=' -JPa8c/'+str(ang)
	ticks=' -B20/0.1wEsN:."": '
	os.system("surface "+TOMO_LONG1+' '+region+' -I0.1/0.005 -V -Gslice.grd -Lu1 ')
	os.system("grdimage "+region+proj+XY+" slice.grd "+ticks+" -CTomo.cpt -O -P -K >> tomo.ps ")
	os.system("psxy "+refsxy+" -Sc0.1 -G0/255/0 -W2 "+region+proj+XY+" -O -P -K -N >> tomo.ps ")
	os.system("psxy lon1_660.xy  "+region+proj+XY+" -M -V -O -P -K >> tomo.ps ")
	# ================================================================================
	# FIND BOUNDS AND MAKE GRID FILE FOR 2nd LINE
	# ================================================================================
	mnmx=commands.getoutput('minmax '+TOMO_LONG).split('\t')	
	xs=mnmx[1].split('<')[1]
	ys=mnmx[2].split('<')[1]
	ts=mnmx[3].split('<')[1]
	xmn=float(xs.split('/')[0])
	xmx=float(xs.split('/')[1].split('>')[0])
	ymn=float(ys.split('/')[0])
	ymx=float(ys.split('/')[1].split('>')[0])
	tmn=float(ts.split('/')[0])
	tmx=float(ts.split('/')[1].split('>')[0])
	# DEFINE REGION 
	west=str(xmn)
	east=str(xmx)
	south='0.65'
	#south='0.8'
	north=str(ymx)
	region=' -R'+west+'/'+east+'/'+south+'/'+north+' '
	ang = float(west) + ( float(east) - float(west) ) / 2
	proj=' -JPa8c/'+str(ang)
	ticks=' -B20/0.1wEsN:."": '
	os.system("surface "+TOMO_LONG+' '+region+' -I0.1/0.005 -V -Gslice.grd -Lu1 ')
	os.system("grdimage "+region+proj+XY2+" slice.grd "+ticks+" -CTomo.cpt -O -P -K >> tomo.ps ")
	os.system("psxy "+refsxyb+" -Sc0.1 -G255/0/0 -W2 "+region+proj+XY2+" -O -P -K -N >> tomo.ps ")
	os.system("psxy lon660.xy  "+region+proj+XY2+" -M -V -O -P -K >> tomo.ps ")



# ============================================================
# 
# ============================================================
# PLOT SCALE BAR FOR TOMO
position=' -Xa3.3   -Ya1.8  '
scalepar="-D1.4/-0.1/6.0c/0.2h"
os.system(" psscale -CTomo.cpt "+scalepar+"   -B1.0:"":/:"+'"Velocity Perturbation (m/s)"'+":  "+position+"  -P -K -V -O >> tomo.ps")

# PLOT SCALE BAR FOR TEMP
position=' -Xa3.3   -Ya18.3 '
scalepar="-D1.4/-0.1/6.0c/0.2h"
os.system(" psscale -Cout.cpt "+scalepar+"   -B0.5:"":/:"+'"Temperature (C)"'+":  "+position+"  -P -K -V -O >> tomo.ps")

# ============================================================
# 	PLOT BASEMAP SHOWING LOCATION OF SECTIONS
# ============================================================
#P=' -JS140/-30/6c '
#P=' -Jm0.05c '
P=' -JB150/-29.5/-5/-50/5 '
#R=' -R65/-50/180/0r '
R=' -R110/190/-60/0 '
ticks=' -Ba30f30WesN:."": '

off=" -Xa2.5 -Ya23.8 "
#off=" -Xa7.9i  -Ya15.5 "
os.system("pscoast -W  -V -I1 -N1  -P -K -O -V "+P+R+ticks+off+"  >> tomo.ps ")
os.system("psxy "+pp_bird+" -V -O -P -K -M  "+P+R+ticks+off+" >>tomo.ps")
os.system("psxy "+subductions+" -W3 -O -P -K -M -Sf0.2/0.07rt -G0/0/0 "+P+R+ticks+off+" >> tomo.ps")

os.system("psxy newsample.xy -W4  "+P+R+ticks+off+" -O -P -K  >>tomo.ps")
os.system("psxy newsampleb.xy -W4  "+P+R+ticks+off+" -O -P -K  >> tomo.ps")
os.system("psxy "+refs+" -Sc0.08 -G0/255/0 -W0/0/0 "+P+R+ticks+off+" -O -P -K  >>tomo.ps")
os.system("psxy "+refsb+" -Sc0.08 -G255/0/0 -W0/0/0 "+P+R+ticks+off+" -O -P -K  >> tomo.ps")

# ============================================================
# 
# ============================================================
# PLOT THE ROW1 NAMES
LT=open("label.txt","w")
#txt1='S20RTS'
txt1='MITP08'
print >> LT, '74 10.0 18 0 0 1 '+txt1
LT.close() 
os.system("pstext label.txt -JX25c -R0/100/0/20  -O -P -K  -V -G0/0/0  -W255/255/255  >>   tomo.ps")

# PLOT THE ROW3 NAMES
LT=open("label.txt","w")
#txt1='TX2007'
txt1='PRI-P05'
print >> LT, '74 6.0 18 0 0 1 '+txt1
LT.close() 
os.system("pstext label.txt -JX25c -R0/100/0/20  -O -P -K  -V -G0/0/0  -W255/255/255  >>   tomo.ps")

# PLOT THE ROW3 NAMES
LT=open("label.txt","w")
#txt1='TXBW'
txt1='S20RTS'
print >> LT, '74 2.5 18 0 0 1 '+txt1
LT.close() 
os.system("pstext label.txt -JX25c -R0/100/0/20  -O -P -K  -V -G0/0/0  -W255/255/255  >>   tomo.ps")


# ============================================================
# 
# ============================================================
os.system("echo  0. 0. | psxy -R -J -W1 -P -O >> tomo.ps")











