#!/usr/bin/env python

# ============================================================
# LOAD PYTHON MODULES
# ============================================================
import sys, string, os, math, commands, random
import CitcomParser
import Core_Citcom, Core_Util
import Core_GMT, Core_File
Core_Citcom.verbose = True
Core_GMT.verbose = True


# ============================================================
# LOAD PYTHON MODULES
# ============================================================
import sys, string, os, math, commands, random
import CitcomParser
import Core_Citcom, Core_Util
import Core_GMT, Core_File
Core_Citcom.verbose = True
Core_GMT.verbose = True
import ROTATION_FUNCTIONS
# ======================================================================
#	IMPORT PLOTTING MODULES
# ======================================================================
import pylab, numpy
from pylab import randn, hist, matplotlib
import matplotlib.pyplot as P
from matplotlib import collections, axes, transforms
from matplotlib.colors import colorConverter
import numpy as N
# ======================================================================
#	IMPORT CITCOM EXTRACTING MODULES
# ======================================================================
import CitcomParser
import Core_Citcom, Core_Util
import Core_GMT, Core_File
Core_Citcom.verbose = True
Core_GMT.verbose = True


# ======================================================================
#	DEFINE ROTATE PLANE BY SOME ROT FILE AND TIME FUNCTION
# ======================================================================
def rotplane( plane,time):
	t=str(time)
	plists=open(plane,'r')
	plist=plists.readlines()
	write_newxy=open('new.xy','w')
	depths=[]
	lats0=[]
	longs0=[]
	print "reading values into format"
	for o in range(len(plist)):
		lo=(float((string.split(plist[o],'\t')[0])))
		la=(float((string.split(plist[o],'\t')[1])))
		depth=(float((string.split(plist[o],'\t')[2])))
		short_lo= "%6.3f" % lo
		short_la= "%6.3f" % la
		short_depths="%6.3f" % depth
		depths.append(short_depths)
		lats0.append(short_la)
		longs0.append(short_lo)
		line = '%s \t %s \n' % (short_lo, short_la)
		write_newxy.write(line)
	write_newxy.close()
	os.system("awk ' { print("+'" "'+", $2, "+'" "'+", $1,"+'" "'+", 2)} ' new.xy > "+t+"Ma.xyz")
	os.system("cat dependencies/Header.txt "+t+"Ma.xyz dependencies/Tail.txt > "+t+".dat ")
	print "rotating values"
	os.system(ROTPROG+" "+t+" 001 "+t+".dat "+ROTFILE)
	return depths, lats0, longs0


# ======================================================================
#	ROTPTS
# ======================================================================
def rotpts( plane,time):
	t=str(time)
	ROTFILE='/home/lydia/Model_0.8.8_shiftedwest/Global_EarthByte_20070427.rot'
	GETROT='/home/lydia/GPLATES/ROTATIONAL_VELOCITIES/getrot'
	rotation=commands.getoutput(GETROT+" 801 001 -t "+t+" -r "+ROTFILE)
	plists=open(plane,'r')
	plist=plists.readlines()
	write_newxy=open('new.xy','w')
	depths=[]
	lats0=[]
	longs0=[]
	print "reading values into format"
	for o in range(len(plist)):
		lo=(float((string.split(plist[o],'\t')[0])))
		la=(float((string.split(plist[o],'\t')[1])))
		depth=(float((string.split(plist[o],'\t')[2])))
		short_lo= "%6.3f" % lo
		short_la= "%6.3f" % la
		short_depths="%6.3f" % depth
		depths.append(short_depths)
		lats0.append(short_la)
		longs0.append(short_lo)
		line = '%s \t %s \n' % (short_lo, short_la)
		write_newxy.write(line)
	write_newxy.close()
	os.system("rotpts new.xy "+rotation+" > "+str(time)+".xy")
	return depths, lats0, longs0

# ======================================================================

# ======================================================================
def rotptspole( plane,time):
	t=str(time)
	depthinfo=open(plane,'r')
	depthr=depthinfo.readlines()
	depths=[]
	for i in range(len(depthr)):
		depth=str(float(depthr[i].split('\t')[2]))
		lon=str(float(depthr[i].split('\t')[0]))
		lat=str(float(depthr[i].split('\t')[1]))
		depths.append(depth)
	rotation=commands.getoutput(GETROT+" 801 001 -t "+t+" -r "+ROTFILE)
	latlon=str((rotation.split(' ')[0])+' '+(rotation.split(' ')[1]))
	angle=str(float(rotation.split(' ')[2]))
	angleback=str(float(angle)*-1)
	newrotation=latlon+' '+angleback
	os.system("rotpts "+plane+" "+newrotation+" > "+str(time)+".xy")
	pos=open(str(time)+".xy",'r')
	rpos=pos.readlines()
	rotatedfile=open('rot'+str(time)+".xy",'w')
	for o in range(len(rpos)):
		lon_n=rpos[o].split('\t')[0]
		lat_n=str(float(rpos[o].split('\t')[1]))
		depth_n=depths[o]
		newline=(lon_n+' '+lat_n+' '+depth_n+' \n')
		rotatedfile.write(newline)
	rotatedfile.close()
	return depths

# ======================================================================

# ======================================================================
def rotptsrecon( plane,time):
	t=str(time)
	depthinfo=open(plane,'r')
	depthr=depthinfo.readlines()
	depths=[]
	for i in range(len(depthr)):
		depth=str(float(depthr[i].split('\t')[2]))
		lon=str(float(depthr[i].split('\t')[0]))
		lat=str(float(depthr[i].split('\t')[1]))
		depths.append(depth)
	rotation=commands.getoutput(GETROT+" 801 001 -t "+t+" -r "+ROTFILE)
	latlon=str((rotation.split(' ')[0])+' '+(rotation.split(' ')[1]))
	angle=str(float(rotation.split(' ')[2]))
	angleback=str(float(angle)*-1)
	newrotation=latlon+' '+angleback
	os.system("rotpts "+plane+" "+rotation+" > "+str(time)+".xy")
	pos=open(str(time)+".xy",'r')
	rpos=pos.readlines()
	rotatedfile=open('rot'+str(time)+".xy",'w')
	for o in range(len(rpos)):
		lon_n=rpos[o].split('\t')[0]
		lat_n=str(float(rpos[o].split('\t')[1]))
		depth_n=depths[o]
		newline=(lon_n+' '+lat_n+' '+depth_n+' \n')
		rotatedfile.write(newline)
	rotatedfile.close()
	return depths

# ======================================================================
#	ROTATE COORDINATES BACK TO A REFERENCE DEFINED BY lats0 and longs0
#
# ======================================================================
def  rotbackref(filename,lats0,longs0):
	sampled=open(filename,'r')
	sampledr=sampled.readlines()
	longsr=[]
	latsr=[]
	new_depths=[]
	ref0Ma=open('refram0.xyz','w')
	for li in range(len(sampledr)-1):
		line=sampledr[li]
		lonr=line.split('\t')[0]	
		latr=line.split('\t')[1]
		depth=float(line.split('\t')[2])
		longsr.append(lonr)
		latsr.append(latr)
		new_depths.append(depth)
		lon0=longs0[li]
		lat0=lats0[li]
		ref0Ma.write(str(lon0)+' '+str(lat0)+' '+str(depth)+' \n')
	ref0Ma.close()
	sampled.close()
	return latsr,longsr

# ======================================================================
#	ROTATE THE DYNAMIC TOPOGRAPHY OUTPUT BACK TO THE POLE
# ======================================================================
def rotmodel_pole(rotdata,pole,time):
	os.system("rotpts "+rotdata+" "+pole+" > model"+str(time)+".xy")
	locations=open("model"+str(time)+".xy",'r')
	locs=locations.readlines()
	values=open(rotdata,'r')
	vals=values.readlines()
	combined=open("modeldata"+str(time)+".xy",'w')
	for li in range(len(locs)):
		lon=locs[li].split('\t')[0]
		lat=float(locs[li].split('\t')[1])
		val=vals[li].split(' ')[2]
		combined.write(lon+' '+str(lat)+' '+val+' \n')
	combined.close()
	locations.close()
	values.close()

# ======================================================================
#	ROTATE COASTLINE
# ======================================================================
def rotcoast(ROTPROG,time,CSFILE,ROTFILE):
	os.system(ROTPROG+" "+time+" "+CSFILE+" "+ROTFILE)
	# Add a carrot to the top of the file
	carrotf=open('carrot','w')
	carrotf.write('> \n')
	carrotf.close()
	os.system("cat carrot "+time+".xy > coastfile.xy ")
	coastfile='coastfile.xy'
	return coastfile

# ======================================================================
#	PLOT COASTLINE AND AGE INFO
# ======================================================================
def plotcoast(region,XY,time,proj):
	os.system("psxy coastfile.xy -M -J "+region+" -O -K -V -W0/0/0 "+XY+" >> out.ps")
	textf=open('text.txt','w')
	textf.write("105.0 -60.0 20 0 5 6 "+time+"Ma \n")
	textf.close()
	os.system("pstext text.txt -V -O -K "+XY+proj+region+" -G0/0/0 -W255/255/255 >> out.ps")

# ======================================================================
#	PLOT SUBDUCTION ZONES
# ======================================================================
def plotsubdzones(time,XY):
	subductionzonesR='/home/lydia/Model_0.8.8_shiftedwest/OUTPUT_FEATUREDATA/LINES/Polygons.subduction_boundaries_sR.'
	subductionzonesL='/home/lydia/Model_0.8.8_shiftedwest/OUTPUT_FEATUREDATA/LINES/Polygons.subduction_boundaries_sL.'
	age=time
	subr=subductionzonesR+age+'.xy'
	subl=subductionzonesL+age+'.xy'
	os.system("psxy "+subr+" -R -O -K -J "+XY+" -M -V -W3/0/0/0 -Sf0.2/0.07rt  -G0/0/0 -: >>  out.ps")
	os.system("psxy "+subl+" -R -O -K -J "+XY+" -M -V -W3/0/0/0 -Sf0.2/0.07lt  -G0/0/0 -: >>  out.ps")


# ======================================================================
#	PLOT PLATE POLYGONS
# ======================================================================
def plotplatepoly(pp_dir,time,XY):
	filename1 = commands.getoutput('ls '+pp_dir+'/*.platepolygons.%s.xy'% (time) )
	prefixpos = string.find(filename1,'.platepolygons.')
	prefix=filename1[0:prefixpos]
 	pp_file = prefix+".platepolygons.%s.xy" % (time)
	os.system("awk '{if ($0 !~/>/) print($2,"+'"\t"'+",  $1); else print("+'">"'+") } ' "+pp_file+" > readjusted_polys.xy ")
	os.system("psxy readjusted_polys.xy -M -J -R "+XY+" -O -K -V -W0/0/0 >> out.ps")


# ======================================================================
#	FIND STEPS AND TIMES
# ======================================================================
def findsteps(endtime,modelcapdir):
	start_age=140
	#start_age=50
	os.system("cp "+modelcapdir+"embd.time .")
	piddir='/home/lydia/GPLATES/New_gplates/Cookbook_Models/SURFACE/SURFACE_M93/'
	pid_file = piddir+'pid29858.cfg'
	d = Core_Citcom.parse_citcoms_cfg_file(pid_file)
	stepsn=range(0,endtime,100)
	steps=[]
	times=[]
	for step in stepsn:
		filen=open('embd.time','r')
		filer=filen.readlines()
		for m in range(len(filer)):
			if step == int(filer[m].split(' ')[0]):
				#print "found step"
				runtime = Core_Citcom.get_runtime_from_step(pid_file,int(step))
				timemyr = round(runtime,2)
				Age=int(float(start_age-timemyr))
				times.append(Age)
				steps.append(step)
		#else:
			#print "step missing moving on to next step"
		filen.close()
	return (times, steps)
	

# ======================================================================
#	ROTATE XY TO TIME

